!=======================================================================

SUBROUTINE ALLOC1

  USE CONTROL_DATA, ONLY:                                              &
                          MX, MZ, MR
  USE AUXIL       , ONLY:                                              &
                          LOU2, LIN2
  USE STRESSFIELD , ONLY:                                              &
                          TXX, TZXMW, TZZMW
  USE WAVEFIELD   , ONLY:                                              &
                          SEIS, U, VU, W, VW,                          &
                          TU1, TU2, TU3,      XXX,  XZX,  XZZ,         &
                          TW1, TW2, TW3,           XTZX, XTZZ,         &
                                                   XRZX, XRZZ

  IMPLICIT NONE

  INTEGER :: ALLOSTAT

!--------------------------------- allocation of stress arrays --------

  ALLOCATE ( TXX (1:MX),                          STAT=ALLOSTAT )

    IF  ( ALLOSTAT > 0 )  THEN
      WRITE (11,*) '  ALLOCATION ERROR ALLOC1_01, STAT= ', ALLOSTAT
      STOP
    END IF

  ALLOCATE ( TZXMW (1:MX,4), TZZMW (1:MX,4),      STAT=ALLOSTAT )

    IF  ( ALLOSTAT > 0 )  THEN
      WRITE (11,*) '  ALLOCATION ERROR ALLOC1_02, STAT= ', ALLOSTAT
      STOP
    END IF

!--------------------------------- allocation of wave arrays ----------

  ALLOCATE ( SEIS (1:MR),                         STAT=ALLOSTAT )

    IF  ( ALLOSTAT > 0 )  THEN
      WRITE (11,*) '  ALLOCATION ERROR ALLOC1_03, STAT= ', ALLOSTAT
      STOP
    END IF

    SEIS = 0.

  ALLOCATE ( VU (1:MX, 0:MZ), VW (1:MX, 0:MZ),                         &
              U (1:MX, 0:MZ),  W (1:MX, 0:MZ),    STAT=ALLOSTAT )

    IF  ( ALLOSTAT > 0 )  THEN
      WRITE (11,*) '  ALLOCATION ERROR ALLOC1_04, STAT= ', ALLOSTAT
      STOP
    END IF

  ALLOCATE ( TU1 (1:MX), TU2 (1:MX), TU3 (1:MX),                       &
             TW1 (1:MX), TW2 (1:MX), TW3 (1:MX),  STAT=ALLOSTAT )

    IF  ( ALLOSTAT > 0 )  THEN
      WRITE (11,*) '  ALLOCATION ERROR ALLOC1_05, STAT= ', ALLOSTAT
      STOP
    END IF

!--------------------------------- allocation of ksi -------------------

  ALLOCATE ( XXX (1:MX, 0:MZ), XZX (1:MX, 0:MZ), XZZ (1:MX, 0:MZ),     &
                                                  STAT=ALLOSTAT )

    IF  ( ALLOSTAT > 0 )  THEN
      WRITE (11,*) '  ALLOCATION ERROR ALLOC1_06, STAT= ', ALLOSTAT
      STOP
    END IF

  ALLOCATE ( XTZX (1:MX, LOU2:LIN2), XTZZ (1:MX, LOU2:LIN2),           &
             XRZX (1:MX, LOU2:LIN2), XRZZ (1:MX, LOU2:LIN2),           &
                                                  STAT=ALLOSTAT )

    IF  ( ALLOSTAT > 0 )  THEN
      WRITE (11,*) '  ALLOCATION ERROR ALLOC1_07, STAT= ', ALLOSTAT
      STOP
    END IF

END SUBROUTINE ALLOC1
