!=======================================================================

SUBROUTINE ALLOC2

  USE CONTROL_DATA, ONLY:                                              &
                          MX
  USE AUXIL       , ONLY:                                              &
                          MZ3, LINH,                                   &
                          UST02   , UST03   , UST04  ,                 &
                          WST01   , WST02   , WST03  ,                 &
                          UST0MX  , UST0MX1 , UST0MX2,                 &
                          WST0MX  , WST0MX1 , WST0MX2,                 &
                          UST0MZ  , UST0MZ1 , UST0MZ2,                 &
                          WST0MZ  , WST0MZ1 , WST0MZ2,                 &
                          USTM1MZ1, USTM1MZ2,                          &
                          WSTM1MZ1, WSTM1MZ2
  USE NONREF_BOUND, ONLY:                                              &
                                 ALE01, ALE02,        ARI01, ARI02,    &
                          ALE10, ALE11, ALE12, ARI10, ARI11, ARI12,    &
                          ALE20, ALE21, ALE22, ARI20, ARI21, ARI22

  IMPLICIT NONE

  INTEGER :: ALLOSTAT

  ALLOCATE (                  ALE01 (0:LINH), ALE02 (0:LINH),          &
              ALE10 (0:LINH), ALE11 (0:LINH), ALE12 (0:LINH),          &
              ALE20 (0:LINH), ALE21 (0:LINH), ALE22 (0:LINH),          &
                              ARI01 (0:LINH), ARI02 (0:LINH),          &
              ARI10 (0:LINH), ARI11 (0:LINH), ARI12 (0:LINH),          &
              ARI20 (0:LINH), ARI21 (0:LINH), ARI22 (0:LINH),          &
                                                    STAT=ALLOSTAT )
    IF  ( ALLOSTAT > 0 )  THEN
      WRITE (11,*) '  ALLOCATION ERROR ALLOC2_01, STAT= ', ALLOSTAT
      STOP
    END IF

  ALLOCATE (  UST02  (0:MZ3), UST03   (0:MZ3), UST04   (0:MZ3),        &
              WST01  (0:MZ3), WST02   (0:MZ3), WST03   (0:MZ3),        &
              UST0MX (0:MZ3), UST0MX1 (0:MZ3), UST0MX2 (0:MZ3),        &
              WST0MX (0:MZ3), WST0MX1 (0:MZ3), WST0MX2 (0:MZ3),        &
                                                    STAT=ALLOSTAT )
    IF  ( ALLOSTAT > 0 )  THEN
      WRITE (11,*) '  ALLOCATION ERROR ALLOC2_02, STAT= ', ALLOSTAT
      STOP
    END IF

  ALLOCATE (  USTM1MZ2 (1:MX), WSTM1MZ2 (1:MX),                        &
              UST0MZ2  (1:MX), WST0MZ2  (1:MX),                        &
              USTM1MZ1 (1:MX), WSTM1MZ1 (1:MX),                        &
              UST0MZ1  (1:MX), WST0MZ1  (1:MX),                        &
              UST0MZ   (1:MX), WST0MZ   (1:MX),                        &
                                                    STAT=ALLOSTAT )
    IF  ( ALLOSTAT > 0 )  THEN
      WRITE (11,*) '  ALLOCATION ERROR ALLOC2_03, STAT= ', ALLOSTAT
      STOP
    END IF

END SUBROUTINE ALLOC2
