!=======================================================================

SUBROUTINE  AUX1

  USE PRECISION   , ONLY :                                             &
                           WP
  USE GRID_MEDIUM , ONLY :                                             &
                           H, CODEN,  COLAM, COMU, COL2M
  USE CONTROL_DATA, ONLY :                                             &
                           MX, MZ, LHOM, LIN3, DT,                     &
                           COVP, COVS, FRJMAX, FRANGE, KEY_SH
  USE AUXIL       , ONLY :                                             &
                           MX1, MX2, MZ1, MZ2, MZ3, LINH,              &
                           COD, OTA, OSA, PI, LIN1, LIN2,              &
                                              LOU1, LOU2, LOU3

  IMPLICIT NONE

  INTEGER      :: J

  REAL    (WP) :: OH


  MX1   = MX - 1
  MX2   = MX - 2
  MZ1   = MZ - 1
  MZ2   = MZ - 2
  MZ3   = MZ - 3

  LINH  = LHOM - 1

  LIN2  = LIN3 - 1
  LIN1  = LIN3 - 2
  LOU1  = LIN3 - 3
  LOU2  = LIN3 - 4
  LOU3  = LIN3 - 5

  IF ( KEY_SH ) THEN
    COVP = COVS
  END IF

  COD   = DT/(H*CODEN)

  COL2M = CODEN*COVP*COVP/H
  COMU  = CODEN*COVS*COVS/H

  COLAM = CODEN*( COVP*COVP - 2._WP*COVS*COVS )/H

  DO J = 1, 4
    OH=FRJMAX/(10._WP**(FRANGE*REAL(4-J,WP)/3._WP)) * DT *2._WP*PI
    OTA(J)=(2._WP-OH)/(2._WP+OH)
    OSA(J)= 2._WP*OH /(2._WP+OH)
  END DO

END SUBROUTINE  AUX1
