!=======================================================================

SUBROUTINE  DISP_UPDATE (IT)

  USE CONTROL_DATA, ONLY:                                              &
                          LHOM,                                        &
                          DT, IPAS1, MTS, IPAS2,                       &
                          KEY_TLV, KEY_TLD, KEY_SNV, KEY_SND
  USE AUXIL       , ONLY:                                              &
                          LINH, MZ3, MZ2, MZ1
  USE WAVEFIELD   , ONLY:                                              &
                          U, W
  USE T_LOOP      , ONLY:                                              &
                          TR
  USE T_INTERFACES, ONLY:                                              &
                          DISP_INT , INH_D_NR , HOM_D_NR,              &
                          STO_BOU,                                     &
                          STO_BOU_MZ2, HOM_D_NR_MZ2,                   &
                          STO_BOU_MZ1, HOM_D_NR_MZ1,                   &
                                       HOM_D_NR_MZ,                    &
                          REC, REC0, SNAP
  IMPLICIT NONE

  INTEGER, INTENT(IN):: IT

  INTEGER :: L


  TR = (IT-1) * DT

 !_____________________________________________ DISPLACEMENT UPDATES ___

  DO  L = 0, LINH
    CALL STO_BOU  (L)
    CALL DISP_INT (L)
    CALL INH_D_NR (L)
  END DO

  DO  L = LHOM, MZ3
    CALL STO_BOU  (L)
    CALL DISP_INT (L)
    CALL HOM_D_NR (L)
  END DO

  CALL STO_BOU_MZ2
  CALL DISP_INT (MZ2)
  CALL HOM_D_NR_MZ2

  CALL STO_BOU_MZ1
  CALL DISP_INT (MZ1)
  CALL HOM_D_NR_MZ1

  CALL HOM_D_NR_MZ
!_______________________________________ RECORD FILES - DISPLACEMENT ___

  IF  ( KEY_TLD ) THEN
    IF  ( MOD(IT,IPAS1) .EQ. 0 ) THEN
      CALL  REC  ( T = TR + DT, UT    = U , WT    = W ,                &
                                OP_F1 = 25, OP_F2 = 26 )
      CALL  REC0 ( T = TR + DT, UT    = U , WT    = W ,                &
                                OP_F3 = 27, OP_F4 = 28 )
    END IF
  END IF

  IF  ( KEY_SND ) THEN
    IF  ( IT .LE. MTS ) THEN
      IF  ( MOD(IT,IPAS2) .EQ. 0 ) THEN
        CALL SNAP ( NUMSNAP = IT, UT = U , WT = W,                     &
                    SN_BASE_1 = 'SNAP_DU.', SN_BASE_2 = 'SNAP_DW.' )
      END IF
    END IF
  END IF

END SUBROUTINE  DISP_UPDATE
