!=======================================================================
! I=3,...,MX2
!    XXXT   (I,0   ) =  xi^xx (I,0)
!    TXXT   (I)      = tau_xx (I,0)
! I=3,...,MX2
!    XZZT   (I,0   ) =  xi^zz (I,0)
!    XZZT   (I,1   ) =  xi^zz (I,1)
!    XZZT   (I,2   ) =  xi^zz (I,2)
!    XZZT   (I,3   ) =  xi^zz (I,3)
!    TZZMWT (I,LZZ1) = tau_zz (I,0)
!    TZZMWT (I,LZZ2) = tau_zz (I,1)
!    TZZMWT (I,LZZ3) = tau_zz (I,2)
!    TZZMWT (I,LZZ4) = tau_zz (I,3)
! I=3,...,MX1
!    XZXT   (I,1   ) =  xi^xz (I,1)
!    XZXT   (I,2   ) =  xi^xz (I,2)
!    XZXT   (I,3   ) =  xi^xz (I,3)
!    XZXT   (I,4   ) =  xi^xz (I,4)
!    TZXMWT (I,LZX1) = tau_xz (I,1)
!    TZXMWT (I,LZX2) = tau_xz (I,2)
!    TZXMWT (I,LZX3) = tau_xz (I,3)
!    TZXMWT (I,LZX4) = tau_xz (I,4)
SUBROUTINE  FS0_S_INT  (  JMT,   MX1T,   MX2T,                         &
                          MUT,  MUXZT,   LAMT,                         &
                         YMUT, YMUXZT,  YLAMT,                         &
                           UT,     WT,                                 &
                         XXXT, XZXT  , XZZT  ,                         &
                         TXXT, TZXMWT, TZZMWT  )

  USE PRECISION   , ONLY:                                              &
                          WP, IK
  USE CONTROL_DATA, ONLY:                                              &
                          KEY_1D
  USE AUXIL       , ONLY:                                              &
                          OTA, A, B
  USE T_INTERFACES, ONLY:                                              &
                          IND

  IMPLICIT NONE

  INTEGER     ,                  INTENT(IN)    ::                      &
                                                  MX1T, MX2T
  INTEGER (IK), DIMENSION(:,0:), INTENT(IN)    ::                      &
                                                  JMT
  REAL    (WP), DIMENSION(:)   , INTENT(IN)    ::                      &
                                                   MUT,  MUXZT,  LAMT
  REAL    (WP), DIMENSION(:,:) , INTENT(IN)    ::                      &
                                                  YMUT, YMUXZT, YLAMT
  REAL    (WP), DIMENSION(:)   , INTENT(OUT)   ::                      &
                                                  TXXT
  REAL    (WP), DIMENSION(:,:) , INTENT(OUT)   ::                      &
                                                  TZXMWT, TZZMWT
  REAL    (WP), DIMENSION(:,0:), INTENT(IN)    ::                      &
                                                  UT, WT
  REAL    (WP), DIMENSION(:,0:), INTENT(INOUT) ::                      &
                                                  XXXT, XZXT, XZZT

  INTEGER      :: I, L, JM1, IO,                LP1,  LP2,  LP3,  LP4, &
                               LLM2, LLM1, LL, LLP1, LLP2, LLP3, LLP4, &
                  LZX1, LZX2, LZX3, LZX4, LZZ1, LZZ2, LZZ3, LZZ4

  REAL    (WP) :: LAMIL, LA2MI, W_XI0, YLAMIL, YLA2MI,                 &
                  XT, XT0, OT, ET1, ET2


  L   = 0

  LP1 = L + 1
  LP2 = L + 2
  LP3 = L + 3
  LP4 = L + 4

  IF ( .NOT. KEY_1D ) THEN
    DO  I = 3, MX2T

! coarse graining
      IO     = IND (I,L)
      OT     = OTA (IO)
      JM1    = JMT (I,L)
      YLAMIL = YLAMT (JM1,IO)
       LAMIL =  LAMT (JM1)
      YLA2MI = YLAMIL + 2._WP*YMUT (JM1,IO)
       LA2MI =  LAMIL + 2._WP* MUT (JM1)
! u_x (I,0) == u_x (I+1/2,1/2)
      ET1    = ( A*( UT (I+2,L  ) - UT (I-1,L  ) )                     &
               + B*( UT (I+1,L  ) - UT (I  ,L  ) ) )
! w_z (I,0) == w_z (I+1/2,1/2)        computed by AFDA
      ET2    = ( -11._WP/12._WP * WT (I,L  )                           &
                + 17._WP/24._WP * WT (I,LP1)                           &
                +  3._WP/ 8._WP * WT (I,LP2)                           &
                -  5._WP/24._WP * WT (I,LP3)                           &
                +  1._WP/24._WP * WT (I,LP4)       )
! xi^xx (I,0) == xi^xx (I+1/2,1/2)
      XT0    = XXXT (I,L)
      XT     = OT*XT0 + YLA2MI * ET1 + YLAMIL * ET2
      XXXT (I,L) = XT
! tau_xx (I) == tau_xx (I+1/2,1/2)
      TXXT (I)   = LA2MI * ET1 +  LAMIL * ET2 - ( XT + XT0 ) * 0.5_WP

    END DO

  END IF
!_______________________________________________________________________

  LZZ1 = 1

  LL   = L

  LLP1 = LL + 1
  LLP2 = LL + 2
  LLP3 = LL + 3
  LLP4 = LL + 4

  DO  I = 3, MX2T

! coarse graining
    IO     = IND (I,LL)
    OT     = OTA (IO)
    JM1    = JMT (I,LL)
    YLAMIL = YLAMT (JM1,IO)
     LAMIL =  LAMT (JM1)
    YLA2MI = YLAMIL + 2._WP*YMUT (JM1,IO)
     LA2MI =  LAMIL + 2._WP* MUT (JM1)
! u_x (I,0) == u_x (I+1/2,1/2)
    ET1    = ( A*( UT (I+2,LL  ) - UT (I-1,LL  ) )                     &
             + B*( UT (I+1,LL  ) - UT (I  ,LL  ) ) )
! w_z (I,0) == w_z (I+1/2,1/2)        computed by AFDA
    ET2    = ( -11._WP/12._WP * WT (I,LL  )                            &
              + 17._WP/24._WP * WT (I,LLP1)                            &
              +  3._WP/ 8._WP * WT (I,LLP2)                            &
              -  5._WP/24._WP * WT (I,LLP3)                            &
              +  1._WP/24._WP * WT (I,LLP4)        )
! xi^zz (I,0) == xi^zz (I+1/2,1/2)
    XT0    = XZZT (I,LL)
    XT     = OT*XT0 + YLAMIL * ET1 + YLA2MI * ET2
    XZZT   (I,LL  ) = XT

    TZZMWT (I,LZZ1) = LAMIL * ET1 + LA2MI * ET2                        &
                    - ( XT + XT0 ) * 0.5_WP

    IF ( KEY_1D ) THEN
      IO     = IND (I+1,LL)
      OT     = OTA (IO)
      JM1    = JMT (I,LL)
      YLAMIL = YLAMT (JM1,IO)
       LAMIL =  LAMT (JM1)
      YLA2MI = YLAMIL + 2._WP*YMUT (JM1,IO)
       LA2MI =  LAMIL + 2._WP* MUT (JM1)
! xi^zz (I,0) == xi^zz (I+1/2,1/2)
      XT0    = XXXT (I,LL)
      XT     = OT*XT0 + YLAMIL * ET1 + YLA2MI * ET2
      XXXT   (I,LL  ) = XT

! tau_zz (I,LZZ1) == tau_zz (I+1/2,1/2)
      TZZMWT (I,LZZ1) = TZZMWT (I,LZZ1)                                &
                      - ( XT + XT0 ) * 0.5_WP
    END IF

  END DO

!________________________________________

  LZZ2 = 2

  LL   = L + 1

  LLM1 = LL - 1
  LLP1 = LL + 1
  LLP2 = LL + 2

  DO  I = 3, MX2T

! coarse graining
    IO     = IND (I,LL)
    OT     = OTA (IO)
    JM1    = JMT (I,LL)
    YLAMIL = YLAMT (JM1,IO)
     LAMIL =  LAMT (JM1)
    YLA2MI = YLAMIL + 2._WP*YMUT (JM1,IO)
     LA2MI =  LAMIL + 2._WP* MUT (JM1)
! u_x (I,1) == u_x (I+1/2,3/2)
    ET1    = ( A*( UT (I+2,LL  ) - UT (I-1,LL  ) )                     &
             + B*( UT (I+1,LL  ) - UT (I  ,LL  ) ) )
! w_z (I,1) == w_z (I+1/2,3/2)
    ET2    = ( A*( WT (I  ,LLP2) - WT (I  ,LLM1) )                     &
             + B*( WT (I  ,LLP1) - WT (I  ,LL  ) ) )
! xi^zz (I,1) == xi^zz (I+1/2,3/2)
    XT0    = XZZT (I,LL)
    XT     = OT*XT0 + YLAMIL * ET1 + YLA2MI * ET2
    XZZT   (I,LL  ) = XT
! tau_zz (I,LZZ2) == tau_zz (I+1/2,3/2)
    TZZMWT (I,LZZ2) = LAMIL * ET1 + LA2MI * ET2                        &
                    - ( XT + XT0 ) * 0.5_WP

    IF ( KEY_1D ) THEN
      IO     = IND (I+1,LL)
      OT     = OTA (IO)
      JM1    = JMT (I,LL)
      YLAMIL = YLAMT (JM1,IO)
       LAMIL =  LAMT (JM1)
      YLA2MI = YLAMIL + 2._WP*YMUT (JM1,IO)
       LA2MI =  LAMIL + 2._WP* MUT (JM1)
      XT0    = XXXT (I,LL)
      XT     = OT*XT0 + YLAMIL * ET1 + YLA2MI * ET2
      XXXT   (I,LL  ) = XT

      TZZMWT (I,LZZ2) = TZZMWT (I,LZZ2)                                &
                      - ( XT + XT0 ) * 0.5_WP
    END IF

  END DO

!________________________________________

  LZZ3 = 3

  LL   = L + 2

  LLM1 = LL - 1
  LLP1 = LL + 1
  LLP2 = LL + 2

  DO  I = 3, MX2T

! coarse graining
    IO     = IND (I,LL)
    OT     = OTA (IO)
    JM1    = JMT (I,LL)
    YLAMIL = YLAMT (JM1,IO)
     LAMIL =  LAMT (JM1)
    YLA2MI = YLAMIL + 2._WP*YMUT (JM1,IO)
     LA2MI =  LAMIL + 2._WP* MUT (JM1)
! u_x (I,2) == u_x (I+1/2,5/2)
    ET1    = ( A*( UT (I+2,LL  ) - UT (I-1,LL  ) )                     &
             + B*( UT (I+1,LL  ) - UT (I  ,LL  ) ) )
! w_z (I,2) == w_z (I+1/2,5/2)
    ET2    = ( A*( WT (I  ,LLP2) - WT (I  ,LLM1) )                     &
             + B*( WT (I  ,LLP1) - WT (I  ,LL  ) ) )
! xi^zz (I,2) == xi^zz (I+1/2,5/2)
    XT0    = XZZT (I,LL)
    XT     = OT*XT0 + YLAMIL * ET1 + YLA2MI * ET2
    XZZT   (I,LL  ) = XT
! tau_zz (I,LZZ3) == tau_zz (I+1/2,5/2)
    TZZMWT (I,LZZ3) = LAMIL * ET1 + LA2MI * ET2                        &
                    - ( XT + XT0 ) * 0.5_WP

    IF ( KEY_1D ) THEN
      IO     = IND (I+1,LL)
      OT     = OTA (IO)
      JM1    = JMT (I,LL)
      YLAMIL = YLAMT (JM1,IO)
       LAMIL =  LAMT (JM1)
      YLA2MI = YLAMIL + 2._WP*YMUT (JM1,IO)
       LA2MI =  LAMIL + 2._WP* MUT (JM1)
      XT0    = XXXT (I,LL)
      XT     = OT*XT0 + YLAMIL * ET1 + YLA2MI * ET2
      XXXT   (I,LL  ) = XT

      TZZMWT (I,LZZ3) = TZZMWT (I,LZZ3)                                &
                      - ( XT + XT0 ) * 0.5_WP
    END IF

  END DO

!________________________________________

  LZZ4 = 4

  LL   = L + 3

  LLM1 = LL - 1
  LLP1 = LL + 1
  LLP2 = LL + 2

  DO  I = 3, MX2T

! coarse graining
    IO     = IND (I,LL)
    OT     = OTA (IO)
    JM1    = JMT (I,LL)
    YLAMIL = YLAMT (JM1,IO)
     LAMIL =  LAMT (JM1)
    YLA2MI = YLAMIL + 2._WP*YMUT (JM1,IO)
     LA2MI =  LAMIL + 2._WP* MUT (JM1)
! u_x (I,3) == u_x (I+1/2,7/2)
    ET1    = ( A*( UT (I+2,LL  ) - UT (I-1,LL  ) )                     &
             + B*( UT (I+1,LL  ) - UT (I  ,LL  ) ) )
! w_z (I,3) == w_z (I+1/2,7/2)
    ET2    = ( A*( WT (I  ,LLP2) - WT (I  ,LLM1) )                     &
             + B*( WT (I  ,LLP1) - WT (I  ,LL  ) ) )
! xi^zz (I,3) == xi^zz (I+1/2,7/2)
    XT0    = XZZT (I,LL)
    XT     = OT*XT0 + YLAMIL * ET1 + YLA2MI * ET2
    XZZT   (I,LL  ) = XT
! tau_zz (I,LZZ4) == tau_zz (I+1/2,7/2)
    TZZMWT (I,LZZ4) = LAMIL * ET1 + LA2MI * ET2                        &
                    - ( XT + XT0 ) * 0.5_WP

    IF ( KEY_1D ) THEN
      IO     = IND (I+1,LL)
      OT     = OTA (IO)
      JM1    = JMT (I,LL)
      YLAMIL = YLAMT (JM1,IO)
       LAMIL =  LAMT (JM1)
      YLA2MI = YLAMIL + 2._WP*YMUT (JM1,IO)
       LA2MI =  LAMIL + 2._WP* MUT (JM1)
      XT0    = XXXT (I,LL)
      XT     = OT*XT0 + YLAMIL * ET1 + YLA2MI * ET2
      XXXT   (I,LL  ) = XT

      TZZMWT (I,LZZ4) = TZZMWT (I,LZZ4)                                &
                      - ( XT + XT0 ) * 0.5_WP
    END IF

  END DO

!_______________________________________________________________________

  LZX1 = 1

  LL   = L  + 1

  LLM1 = LL - 1
  LLP1 = LL + 1
  LLP2 = LL + 2

  DO  I = 3, MX1T

! coarse graining
    IO  = IND (I,LL)
    OT  = OTA (IO)
    JM1 = JMT (I,LL)
! u_z (I,0) == - w_x (I,0)
    W_XI0 = -1._WP *                                                   &
            ( A*( WT (I+1,LLM1) - WT (I-2,LLM1) )                      &
            + B*( WT (I  ,LLM1) - WT (I-1,LLM1) ) )
! u_z (I,1) + w_x (I,1) == u_z (I,1) + w_x (I,1)   computed by AFDA
    ET1   = ( A*( WT (I+1,LL  ) - WT (I-2,LL  ) )                      &
            + B*( WT (I  ,LL  ) - WT (I-1,LL  ) )                      &
            -   1._WP/ 22._WP * W_XI0                                  &
            - 577._WP/528._WP * UT (I,LLM1)                            &
            + 201._WP/176._WP * UT (I,LL  )                            &
            -   9._WP/176._WP * UT (I,LLP1)                            &
            +   1._WP/528._WP * UT (I,LLP2)       )
! xi^xz (I,1) == xi^xz (I,1)
    XT0 = XZXT (I,LL)
    XT  = OT*XT0 + YMUXZT (JM1,IO) * ET1
    XZXT   (I,LL  ) = XT
! tau_xz (I,LZX1) == tau_xz (I,1)
    TZXMWT (I,LZX1) = MUXZT (JM1) * ET1 - ( XT + XT0 ) * 0.5_WP

  END DO

!________________________________________

  LZX2 = 2

  LL   = L  + 2

  LLM2 = LL - 2
  LLM1 = LL - 1
  LLP1 = LL + 1

  DO  I = 3, MX1T

! coarse graining
    IO  = IND (I,LL)
    OT  = OTA (IO)
    JM1 = JMT (I,LL)
! u_z (I,2) + w_x (I,2) == u_z (I,2) + w_x (I,2)
    ET1 = ( A*( UT (I  ,LLP1) - UT (I  ,LLM2)                          &
              + WT (I+1,LL  ) - WT (I-2,LL  ) )                        &
          + B*( UT (I  ,LL  ) - UT (I  ,LLM1)                          &
              + WT (I  ,LL  ) - WT (I-1,LL  ) ) )
! xi^xz (I,2) == xi^xz (I,2)
    XT0 = XZXT (I,LL)
    XT  = OT*XT0 + YMUXZT (JM1,IO) * ET1
    XZXT   (I,LL  ) = XT
! tau_xz (I,LZX2) == tau_xz (I,2)
    TZXMWT (I,LZX2) = MUXZT (JM1) * ET1 - ( XT + XT0 ) * 0.5_WP

  END DO

!________________________________________

  LZX3 = 3

  LL   = L  + 3

  LLM2 = LL - 2
  LLM1 = LL - 1
  LLP1 = LL + 1

  DO  I = 3, MX1T

! coarse graining
    IO  = IND (I,LL)
    OT  = OTA (IO)
    JM1 = JMT (I,LL)
! u_z (I,3) + w_x (I,3) == u_z (I,3) + w_x (I,3)
    ET1 = ( A*( UT (I  ,LLP1) - UT (I  ,LLM2)                          &
              + WT (I+1,LL  ) - WT (I-2,LL  ) )                        &
          + B*( UT (I  ,LL  ) - UT (I  ,LLM1)                          &
              + WT (I  ,LL  ) - WT (I-1,LL  ) ) )
! xi^xz (I,3) == xi^xz (I,3)
    XT0 = XZXT (I,LL)
    XT  = OT*XT0 + YMUXZT (JM1,IO) * ET1
    XZXT   (I,LL  ) = XT
! tau_xz (I,LZX3) == tau_xz (I,3)
    TZXMWT (I,LZX3) = MUXZT (JM1) * ET1 - ( XT + XT0 ) * 0.5_WP

  END DO

!________________________________________

  IF ( .NOT.KEY_1D ) THEN
    LZX4 = 4

    LL   = L  + 4

    LLM2 = LL - 2
    LLM1 = LL - 1
    LLP1 = LL + 1

    DO  I = 3, MX1T

! coarse graining
      IO  = IND (I,LL)
      OT  = OTA (IO)
      JM1 = JMT (I,LL)
! u_z (I,4) + w_x (I,4) == u_z (I,4) + w_x (I,4)
      ET1 = ( A*( UT (I  ,LLP1) - UT (I  ,LLM2)                        &
                + WT (I+1,LL  ) - WT (I-2,LL  ) )                      &
            + B*( UT (I  ,LL  ) - UT (I  ,LLM1)                        &
                + WT (I  ,LL  ) - WT (I-1,LL  ) ) )
! xi^xz (I,4) == xi^xz (I,4)
      XT0 = XZXT (I,LL)
      XT  = OT*XT0 + YMUXZT (JM1,IO) * ET1
      XZXT   (I,LL  ) = XT
! tau_xz (I,LZX4) == tau_xz (I,4)
      TZXMWT (I,LZX4) = MUXZT (JM1) * ET1 - ( XT + XT0 ) * 0.5_WP

    END DO
  END IF

END SUBROUTINE  FS0_S_INT
