!=======================================================================
! I=3 and MX1
!    VUT (I,0) = vu (I,0)
! I=2 and MX1
!    VWT (I,0) = vw (I,0)
SUBROUTINE  FS0_V_2ND  (   JMT,   MX1T,                                &
                         DENUT,  DENWT,                                &
                           VUT,    VWT,                                &
                          TXXT, TZXMWT, TZZMWT )

  USE PRECISION, ONLY:                                                 &
                       WP, IK

  IMPLICIT NONE

  INTEGER     ,                  INTENT(IN)    ::                      &
                                                  MX1T
  INTEGER (IK), DIMENSION(:,0:), INTENT(IN)    ::                      &
                                                  JMT
  REAL    (WP), DIMENSION(:)   , INTENT(IN)    ::                      &
                                                  DENUT, DENWT
  REAL    (WP), DIMENSION(:)   , INTENT(IN)    ::                      &
                                                  TXXT
  REAL    (WP), DIMENSION(:,:) , INTENT(IN)    ::                      &
                                                  TZXMWT, TZZMWT
  REAL    (WP), DIMENSION(:,0:), INTENT(INOUT) ::                      &
                                                  VUT, VWT

  INTEGER :: I, L


  L = 0

  I = 2

  CALL  FS0_VWT_2ND

  I = 3

  CALL  FS0_VUT_2ND

  I = MX1T

  CALL  FS0_VUT_2ND
  CALL  FS0_VWT_2ND


CONTAINS

!-----------------------------------------------------------------------
  SUBROUTINE  FS0_VUT_2ND

    INTEGER :: JM1, LZX1

    LZX1 = 1

    JM1 = JMT (I,L)
! vu (I,0) == vu (I,1/2)
    VUT (I,L) = VUT (I,L) + DENUT (JM1) *                              &
                  ( TXXT   (I)      - TXXT  (I-1)                      &
                  + TZXMWT (I,LZX1)               )

  END SUBROUTINE  FS0_VUT_2ND  

!-----------------------------------------------------------------------
  SUBROUTINE  FS0_VWT_2ND

    INTEGER :: JM1, LZZ1, LZZ2

    LZZ1 = 1
    LZZ2 = 2

    JM1 = JMT (I,L)
! vw (I,0) == vw (I+1/2,0)
    VWT (I,L)   = VWT (I,L) + DENWT(JM1) *                             &
                    (  3._WP       * TZZMWT (I,LZZ1)                   &
                     - 1._WP/3._WP * TZZMWT (I,LZZ2) )

  END SUBROUTINE  FS0_VWT_2ND

END SUBROUTINE  FS0_V_2ND
