!=======================================================================
! I=4,...,MX2
!    VUT (I,L) = vu (I,0)
! I=3,...,MX2
!    VWT (I,L) = vw (I,0)
SUBROUTINE  FS0_V_INT  (   JMT,   MX2T,                                &
                         DENUT,  DENWT,                                &
                           VUT,    VWT,                                &
                          TXXT, TZXMWT, TZZMWT )

  USE PRECISION, ONLY:                                                 &
                       WP, IK
  USE AUXIL    , ONLY:                                                 &
                       A, B

  IMPLICIT NONE

  INTEGER     ,                  INTENT(IN)    ::                      &
                                                  MX2T
  INTEGER (IK), DIMENSION(:,0:), INTENT(IN)    ::                      &
                                                  JMT
  REAL    (WP), DIMENSION(:)   , INTENT(IN)    ::                      &
                                                  DENUT, DENWT
  REAL    (WP), DIMENSION(:)   , INTENT(IN)    ::                      &
                                                  TXXT
  REAL    (WP), DIMENSION(:,:) , INTENT(IN)    ::                      &
                                                  TZXMWT, TZZMWT
  REAL    (WP), DIMENSION(:,0:), INTENT(INOUT) ::                      &
                                                  VUT, VWT

  INTEGER :: I, L, JM1, LZX1, LZX2, LZX3, LZX4, LZZ1, LZZ2, LZZ3, LZZ4


  L    = 0

  LZX1 = 1
  LZX2 = 2
  LZX3 = 3
  LZX4 = 4

  LZZ1 = 1
  LZZ2 = 2
  LZZ3 = 3
  LZZ4 = 4

!! calculation of vu (I,0) == vu (I,1/2)
  DO  I = 4, MX2T

    JM1 = JMT (I,L)
! vu (I,0) ==vu (I,1/2)               computed by AFDA
    VUT (I,L) = VUT (I,L) + DENUT (JM1) *                              &
                  ( A*( TXXT   (I+1)      - TXXT   (I-2) )             &
                  + B*( TXXT   (I  )      - TXXT   (I-1) )             &
                  +  17._WP/24._WP * TZXMWT (I,LZX1)                   &
                  +   3._WP/ 8._WP * TZXMWT (I,LZX2)                   &
                  -   5._WP/24._WP * TZXMWT (I,LZX3)                   &
                  +   1._WP/24._WP * TZXMWT (I,LZX4)      )
  END DO


!! calculation of vw (I,0) == vw (I+1/2,0)
  DO  I = 3, MX2T

    JM1 = JMT (I,L)
! vw (I,0) == vw (I+1/2,0)               computed by AFDA
    VWT (I,L) = VWT (I,L) + DENWT (JM1) *                              &
                  ( 35._WP/ 8._WP * TZZMWT (I,LZZ1)                    &
                  - 35._WP/24._WP * TZZMWT (I,LZZ2)                    &
                  + 21._WP/40._WP * TZZMWT (I,LZZ3)                    &
                  -  5._WP/56._WP * TZZMWT (I,LZZ4) )
  END DO

END SUBROUTINE  FS0_V_INT
