!=======================================================================
! I=2 and MX1
!    XXXT   (I,1   ) =  xi^xx (I,1)
!    TXXT   (I)      = tau_xx (I,1)
! I=2 and MX1
!    XZZT   (I,1   ) =  xi^zz (I,1)
!    TZZMWT (I,LZZ2) = tau_zz (I,1)
! I=2 and MX
!    XZXT   (I,1   ) =  xi^xz (I,1)
!    TZXMWT (I,LZX1) = tau_xz (I,1)
SUBROUTINE  FS1_S_2ND  (  JMT,    MXT,   MX1T,                         &
                          MUT,  MUXZT,   LAMT,                         &
                         YMUT, YMUXZT,  YLAMT,                         &
                           UT,     WT,                                 &
                         XXXT, XZXT  ,                                 &
                         TXXT, TZXMWT          )

  USE PRECISION   , ONLY:                                              &
                          WP, IK
  USE AUXIL       , ONLY:                                              &
                          OTA
  USE T_INTERFACES, ONLY:                                              &
                          IND

  IMPLICIT NONE

  INTEGER     ,                  INTENT(IN)    ::                      &
                                                  MXT, MX1T
  INTEGER (IK), DIMENSION(:,0:), INTENT(IN)    ::                      &
                                                  JMT
  REAL    (WP), DIMENSION(:)   , INTENT(IN)    ::                      &
                                                   MUT,  MUXZT,  LAMT
  REAL    (WP), DIMENSION(:,:) , INTENT(IN)    ::                      &
                                                  YMUT, YMUXZT, YLAMT
  REAL    (WP), DIMENSION(:)   , INTENT(OUT)   ::                      &
                                                  TXXT
  REAL    (WP), DIMENSION(:,:) , INTENT(OUT)   ::                      &
                                                  TZXMWT
  REAL    (WP), DIMENSION(:,0:), INTENT(IN)    ::                      &
                                                  UT, WT
  REAL    (WP), DIMENSION(:,0:), INTENT(INOUT) ::                      &
                                                  XXXT, XZXT

  INTEGER :: I, L, LP1, LM1


  L   = 1

  LM1 = L - 1
  LP1 = L + 1

  I = 2

  CALL  FS1_TXXT_2ND
  CALL  FS1_TZXT_2ND

  I = MX1T

  CALL  FS1_TXXT_2ND

  I = MXT

  CALL  FS1_TZXT_2ND


CONTAINS

!----------------------------------------------------------------------- 
  SUBROUTINE  FS1_TXXT_2ND

    INTEGER      :: JM1, IO
    REAL    (WP) :: LAMIL, LA2MI, YLAMIL, YLA2MI, XT, XT0, OT, ET1, ET2

! coarse graining
    IO     = IND (I,L)
    OT     = OTA (IO)
    JM1    = JMT (I,L)
    YLAMIL = YLAMT (JM1,IO)
     LAMIL =  LAMT (JM1)
    YLA2MI = YLAMIL + 2._WP*YMUT (JM1,IO)
     LA2MI =  LAMIL + 2._WP* MUT (JM1)
! u_x (I,1) == u_x (I+1/2,3/2)
    ET1    = UT (I+1,L  ) - UT (I  ,L  )
! w_z (I,1) == w_z (I+1/2,3/2)
    ET2    = WT (I  ,LP1) - WT (I  ,L  )
! xi^xx (I,1) == xi^xx (I+1/2,3/2)
    XT0    = XXXT (I,L)
    XT     = OT*XT0 + YLA2MI * ET1 + YLAMIL * ET2
    XXXT (I,L) = XT
! tau_xx (I) == tau_xx (I+1/2,3/2)
    TXXT (I)  = LA2MI * ET1 +  LAMIL * ET2 - ( XT + XT0 ) * 0.5_WP

  END SUBROUTINE  FS1_TXXT_2ND

!-----------------------------------------------------------------------
  SUBROUTINE  FS1_TZXT_2ND

    INTEGER      :: JM1, IO, LZX1
    REAL    (WP) :: XT, XT0, OT, ET1

    LZX1 = 1

! coarse graining
    IO  = IND (I,L)
    OT  = OTA (IO)
    JM1 = JMT (I,L)
! u_z (I,1) + w_x (I,1) == u_z (I,1) + w_x (I,1)
    ET1 = UT (I  ,L  ) - UT (I  ,LM1)                                  &
        + WT (I  ,L  ) - WT (I-1,L  )
! xi^xz (I,1) == xi^xz (I,1)
    XT0 = XZXT (I,L)
    XT  = OT*XT0 + YMUXZT (JM1,IO) * ET1
    XZXT   (I,L   ) = XT
! tau_xz (I,LZX1) == tau_xz (I,1)
    TZXMWT (I,LZX1) = MUXZT (JM1) * ET1 - ( XT + XT0 ) * 0.5_WP

  END SUBROUTINE  FS1_TZXT_2ND

END SUBROUTINE  FS1_S_2ND
