!=======================================================================
! I=3,...,MX2
!    XXXT   (I,1) =  xi^xx (I,1)
!    TXXT   (I)   = tau_xx (I,1)
SUBROUTINE  FS1_S_INT  (  JMT,           MX2T,                         &
                          MUT,           LAMT,                         &
                         YMUT,          YLAMT,                         &
                           UT,     WT,                                 &
                         XXXT,                                         &
                         TXXT                  )

  USE PRECISION   , ONLY:                                              &
                          WP, IK
  USE AUXIL       , ONLY:                                              &
                          OTA, A, B
  USE T_INTERFACES, ONLY:                                              &
                          IND

  IMPLICIT NONE

  INTEGER     ,                  INTENT(IN)    ::                      &
                                                  MX2T
  INTEGER (IK), DIMENSION(:,0:), INTENT(IN)    ::                      &
                                                  JMT
  REAL    (WP), DIMENSION(:)   , INTENT(IN)    ::                      &
                                                   MUT,  LAMT
  REAL    (WP), DIMENSION(:,:) , INTENT(IN)    ::                      &
                                                  YMUT, YLAMT
  REAL    (WP), DIMENSION(:)   , INTENT(OUT)   ::                      &
                                                  TXXT
  REAL    (WP), DIMENSION(:,0:), INTENT(IN)    ::                      &
                                                  UT, WT
  REAL    (WP), DIMENSION(:,0:), INTENT(INOUT) ::                      &
                                                  XXXT

  INTEGER      :: I, L, JM1, IO, LM1, LP1, LP2

  REAL    (WP) :: LAMIL, LA2MI, YLAMIL, YLA2MI,                        &
                  XT, XT0, OT, ET1, ET2


  L   = 1

  LM1 = L - 1
  LP1 = L + 1
  LP2 = L + 2

  DO  I = 3, MX2T

! coarse graining
    IO     = IND (I,L)
    OT     = OTA (IO)
    JM1    = JMT (I,L)
    YLAMIL = YLAMT (JM1,IO)
     LAMIL =  LAMT (JM1)
    YLA2MI = YLAMIL + 2._WP*YMUT (JM1,IO)
     LA2MI =  LAMIL + 2._WP* MUT (JM1)
! u_x (I,1) == u_x (I+1/2,3/2)
    ET1    = ( A*( UT (I+2,L  ) - UT (I-1,L  ) )                       &
             + B*( UT (I+1,L  ) - UT (I  ,L  ) ) )
! w_z (I,1) == w_z (I+1/2,3/2)
    ET2    = ( A*( WT (I  ,LP2) - WT (I  ,LM1) )                       &
             + B*( WT (I  ,LP1) - WT (I  ,L  ) ) )
! xi^xx (I,1) == xi^xx (I+1/2,3/2)
    XT0    = XXXT(I,L)
    XT     = OT*XT0 + YLA2MI * ET1 + YLAMIL * ET2
    XXXT (I,L) = XT
! tau_xx (I) == tau_xx (I+1/2,3/2)
    TXXT (I)   = LA2MI * ET1 +  LAMIL * ET2 - ( XT + XT0 ) * 0.5_WP

  END DO

END SUBROUTINE  FS1_S_INT
