!=======================================================================
! I=3 and MX1
!    VUT (I,L) = vu (I,1)
! I=2 and MX1
!    VWT (I,L) = vw (I,1)
SUBROUTINE  FS1_V_2ND  (   JMT,   MX1T,                                &
                         DENUT,  DENWT,                                &
                           VUT,    VWT,                                &
                          TXXT, TZXMWT, TZZMWT )

  USE PRECISION   , ONLY:                                              &
                          WP, IK

  IMPLICIT NONE

  INTEGER     ,                  INTENT(IN)    ::                      &
                                                  MX1T
  INTEGER (IK), DIMENSION(:,0:), INTENT(IN)    ::                      &
                                                  JMT
  REAL    (WP), DIMENSION(:)   , INTENT(IN)    ::                      &
                                                  DENUT, DENWT
  REAL    (WP), DIMENSION(:)   , INTENT(IN)    ::                      &
                                                  TXXT
  REAL    (WP), DIMENSION(:,:) , INTENT(IN)    ::                      &
                                                  TZXMWT, TZZMWT
  REAL    (WP), DIMENSION(:,0:), INTENT(INOUT) ::                      &
                                                  VUT, VWT

  INTEGER :: I, L


  L = 1

  I = 2

  CALL  FS1_VWT_2ND

  I = 3

  CALL  FS1_VUT_2ND

  I = MX1T

  CALL  FS1_VUT_2ND
  CALL  FS1_VWT_2ND


CONTAINS

!-----------------------------------------------------------------------
  SUBROUTINE  FS1_VUT_2ND

    INTEGER :: JM1, LZX1, LZX2

    LZX1 = 1
    LZX2 = 2

    JM1 = JMT (I,L)
! vu (I,1) == vu (I,3/2)
    VUT (I,L) = VUT (I,L) + DENUT (JM1) *                              &
                  ( TXXT   (I)      - TXXT   (I-1)                     &
                  + TZXMWT (I,LZX2) - TZXMWT (I  ,LZX1) )

  END SUBROUTINE  FS1_VUT_2ND

!-----------------------------------------------------------------------
  SUBROUTINE  FS1_VWT_2ND

    INTEGER :: JM1, LZX1, LZZ1, LZZ2

    LZX1 = 1
    LZZ1 = 1
    LZZ2 = 2

    JM1 = JMT (I,L)
! vw (I,1) == vw (I+1/2,1)
    VWT (I,L) = VWT (I,L) + DENWT (JM1) *                              &
                  ( TZZMWT (I  ,LZZ2) - TZZMWT (I  ,LZZ1)              &
                  + TZXMWT (I+1,LZX1) - TZXMWT (I  ,LZX1) )

  END SUBROUTINE  FS1_VWT_2ND

END SUBROUTINE  FS1_V_2ND
