!=======================================================================
! I=4,...,MX2
!    VUT (I,L) = vu (I,1)
! I=3,...,MX2
!    VWT (I,L) = vw (I,1)
SUBROUTINE  FS1_V_INT  (   JMT,   MX2T,                                &
                         DENUT,  DENWT,                                &
                           VUT,    VWT,                                &
                          TXXT, TZXMWT, TZZMWT )

  USE PRECISION, ONLY:                                                 &
                       WP, IK
  USE AUXIL    , ONLY:                                                 &
                       A, B

  IMPLICIT NONE

  INTEGER     ,                  INTENT(IN)    ::                      &
                                                  MX2T
  INTEGER (IK), DIMENSION(:,0:), INTENT(IN)    ::                      &
                                                  JMT
  REAL    (WP), DIMENSION(:)   , INTENT(IN)    ::                      &
                                                  DENUT, DENWT
  REAL    (WP), DIMENSION(:)   , INTENT(IN)    ::                      &
                                                  TXXT
  REAL    (WP), DIMENSION(:,:) , INTENT(IN)    ::                      &
                                                  TZXMWT, TZZMWT
  REAL    (WP), DIMENSION(:,0:), INTENT(INOUT) ::                      &
                                                  VUT, VWT

  INTEGER :: I, L, JM1, LZX1, LZX2, LZX3, LZZ1, LZZ2, LZZ3, LZZ4


  L    = 1

!! calculation of vu (I,1) == vu (I,3/2)

  LZX1 = 1
  LZX2 = 2
  LZX3 = 3

  DO  I = 4, MX2T

    JM1 = JMT (I,L)
! vu (I,1) == vu (I,3/2)
    VUT (I,L) = VUT (I,L) + DENUT (JM1) *                              &
                  ( A*( TXXT   (I+1)      - TXXT   (I-2)               &
                      + TZXMWT (I  ,LZX3)                     )        &
                  + B*( TXXT   (I  )      - TXXT   (I-1)               &
                      + TZXMWT (I  ,LZX2) - TZXMWT (I  ,LZX1) ) )

  END DO

!! calculation of vw (I,1) == vw (I+1/2,1)

  LZZ1 = 1
  LZZ2 = 2
  LZZ3 = 3
  LZZ4 = 4

  DO  I = 3, MX2T

    JM1 = JMT (I,L)
! vw (I,1) == vw (I+1/2,1)          computed by AFDA
    VWT (I,L) = VWT (I,L) + DENWT (JM1) *                              &
                  ( A*( TZXMWT (I+2,LZX1) - TZXMWT (I-1,LZX1) )        &
                  + B*( TZXMWT (I+1,LZX1) - TZXMWT (I  ,LZX1) )        &
                  - 31._WP/ 24._WP * TZZMWT (I,LZZ1)                   &
                  + 29._WP/ 24._WP * TZZMWT (I,LZZ2)                   &
                  -  3._WP/ 40._WP * TZZMWT (I,LZZ3)                   &
                  +  1._WP/168._WP * TZZMWT (I,LZZ4)            )

  END DO

END SUBROUTINE  FS1_V_INT
