!=======================================================================
! I=3 and MX1
!    VUT (I,L) = vu (I,2)
! I=2 and MX1
!    VWT (I,L) = vw (I,2)
SUBROUTINE  FS2_V_2ND  (   JMT,   MX1T,                                &
                         DENUT,  DENWT,                                &
                           VUT,    VWT,                                &
                          TXXT, TZXMWT, TZZMWT )

  USE PRECISION   , ONLY:                                              &
                          WP, IK

  IMPLICIT NONE

  INTEGER     ,                  INTENT(IN)    ::                      &
                                                   MX1T
  INTEGER (IK), DIMENSION(:,0:), INTENT(IN)    ::                      &
                                                   JMT
  REAL    (WP), DIMENSION(:)   , INTENT(IN)    ::                      &
                                                   DENUT, DENWT
  REAL    (WP), DIMENSION(:)   , INTENT(IN)    ::                      &
                                                  TXXT
  REAL    (WP), DIMENSION(:,:) , INTENT(IN)    ::                      &
                                                  TZXMWT, TZZMWT
  REAL    (WP), DIMENSION(:,0:), INTENT(INOUT) ::                      &
                                                  VUT, VWT

  INTEGER :: I, L


  L = 2

  I = 2

  CALL  FS2_VWT_2ND

  I = 3

  CALL  FS2_VUT_2ND

  I = MX1T

  CALL  FS2_VUT_2ND
  CALL  FS2_VWT_2ND


CONTAINS

!-----------------------------------------------------------------------
  SUBROUTINE  FS2_VUT_2ND

    INTEGER :: JM1, LZX2, LZX3

    LZX2 = 2
    LZX3 = 3

    JM1 = JMT (I,L)
! vu (I,2) == vu (I,5/2)
    VUT (I,L) = VUT (I,L) + DENUT (JM1) *                              &
                  ( TXXT   (I)      - TXXT   (I-1)                     &
                  + TZXMWT (I,LZX3) - TZXMWT (I  ,LZX2) )

  END SUBROUTINE  FS2_VUT_2ND

!-----------------------------------------------------------------------
  SUBROUTINE  FS2_VWT_2ND

    INTEGER :: JM1, LZX2, LZZ2, LZZ3

    LZX2 = 2
    LZZ2 = 2
    LZZ3 = 3

    JM1 = JMT (I,L)
! vw (I,2) == vw (I+1/2,2)
    VWT (I,L) = VWT (I,L) + DENWT (JM1) *                              &
                  ( TZZMWT (I  ,LZZ3) - TZZMWT (I  ,LZZ2)              &
                  + TZXMWT (I+1,LZX2) - TZXMWT (I  ,LZX2) )

  END SUBROUTINE  FS2_VWT_2ND

END SUBROUTINE  FS2_V_2ND
