!=======================================================================
! I=4,...,MX2
!    VUT (I,L) = vu (I,2)
! I=3,...,MX2
!    VWT (I,L) = vw (I,2)
SUBROUTINE  FS2_V_INT  (   JMT,   MX2T,                                &
                         DENUT,  DENWT,                                &
                           VUT,    VWT,                                &
                          TXXT, TZXMWT, TZZMWT )

  USE PRECISION, ONLY:                                                 &
                       WP, IK
  USE AUXIL    , ONLY:                                                 &
                       A, B

  IMPLICIT NONE

  INTEGER     ,                  INTENT(IN)    ::                      &
                                                  MX2T
  INTEGER (IK), DIMENSION(:,0:), INTENT(IN)    ::                      &
                                                  JMT
  REAL    (WP), DIMENSION(:)   , INTENT(IN)    ::                      &
                                                  DENUT, DENWT
  REAL    (WP), DIMENSION(:)   , INTENT(IN)    ::                      &
                                                  TXXT
  REAL    (WP), DIMENSION(:,:) , INTENT(IN)    ::                      &
                                                  TZXMWT, TZZMWT
  REAL    (WP), DIMENSION(:,0:), INTENT(INOUT) ::                      &
                                                  VUT, VWT

  INTEGER :: I, L, JM1, LZX1, LZX2, LZX3, LZX4, LZZ1, LZZ2, LZZ3, LZZ4


  L    = 2

!! calculation of vu (I,2) == vu (I,5/2)

  LZX1 = 1
  LZX2 = 2
  LZX3 = 3
  LZX4 = 4


  DO  I = 4, MX2T

    JM1 = JMT (I,L)
! vu (I,2) == vu (I,5/2)
    VUT (I,L) = VUT (I,L) + DENUT (JM1) *                              &
                  ( A*( TXXT   (I+1)      - TXXT   (I-2)               &
                      + TZXMWT (I  ,LZX4) - TZXMWT (I  ,LZX1) )        &
                  + B*( TXXT   (I  )      - TXXT   (I-1)               &
                      + TZXMWT (I  ,LZX3) - TZXMWT (I  ,LZX2) ) )

  END DO

!! calculation of vw (I,2) == vw (I+1/2,2)

  LZZ1 = 1
  LZZ2 = 2
  LZZ3 = 3
  LZZ4 = 4

  DO  I = 3, MX2T

    JM1 = JMT (I,L)
! vw (I,2) == vw (I+1/2,2)
    VWT (I,L) = VWT (I,L) + DENWT (JM1) *                              &
                  ( A*( TZXMWT (I+2,LZX2) - TZXMWT (I-1,LZX2)          &
                      + TZZMWT (I  ,LZZ4) - TZZMWT (I  ,LZZ1) )        &
                  + B*( TZXMWT (I+1,LZX2) - TZXMWT (I  ,LZX2)          &
                      + TZZMWT (I  ,LZZ3) - TZZMWT (I  ,LZZ2) ) )

  END DO

END SUBROUTINE  FS2_V_INT
