!=======================================================================

SUBROUTINE  HLINE_2

  USE GRID_MEDIUM , ONLY:                                              &
                          JM,  LAM,  MU,  MUXZ,                        &
                              YLAM, YMU, YMUXZ,                        &
                              DENU, DENW
  USE CONTROL_DATA, ONLY:                                              &
                          MX, KEY_1D
  USE AUXIL       , ONLY:                                              &
                          MX1, MX2
  USE WAVEFIELD   , ONLY:                                              &
                          U, W, VU, VW,                                &
                          XXX, XZX, XZZ
  USE STRESSFIELD , ONLY:                                              &
                          TXX, TZXMW, TZZMW
  USE T_INTERFACES, ONLY:                                              &
                          FS2_S_INT, FS2_S_2ND, FS2_V_INT, FS2_V_2ND

  IMPLICIT NONE


  IF ( .NOT. KEY_1D ) THEN
    CALL  FS2_S_INT(                  JMT = JM   ,                     &
                                                     MX2T = MX2  ,     &
                       MUT =  MU ,                   LAMT =  LAM ,     &
                      YMUT = YMU ,                  YLAMT = YLAM ,     &
                        UT = U   ,     WT = W    ,                     &
                      XXXT = XXX ,                                     &
                      TXXT = TXX                                   )
  END IF

  CALL  FS2_S_2ND  (                  JMT = JM   ,                     &
                       MXT = MX  ,   MX1T = MX1  ,                     &
                       MUT =  MU ,  MUXZT =  MUXZ,   LAMT =  LAM ,     &
                      YMUT = YMU , YMUXZT = YMUXZ,  YLAMT = YLAM ,     &
                        UT = U   ,     WT = W    ,                     &
                      XXXT = XXX , XZXT   = XZX  , XZZT   = XZZ  ,     &
                      TXXT = TXX , TZXMWT = TZXMW, TZZMWT = TZZMW  )

  CALL  FS2_V_INT  (                  JMT = JM   ,                     &
                                                     MX2T = MX2  ,     &
                     DENUT = DENU,  DENWT = DENW ,                     &
                       VUT = VU  ,    VWT = VW   ,                     &
                      TXXT = TXX , TZXMWT = TZXMW, TZZMWT = TZZMW  )

  CALL  FS2_V_2ND  (                  JMT = JM   ,                     &
                                     MX1T = MX1  ,                     &
                     DENUT = DENU,  DENWT = DENW ,                     &
                       VUT = VU  ,    VWT = VW   ,                     &
                      TXXT = TXX , TZXMWT = TZXMW, TZZMWT = TZZMW  )

END SUBROUTINE  HLINE_2
