!=======================================================================

SUBROUTINE  HLINE_H ( L )

  USE CONTROL_DATA, ONLY:                                              &
                          MX
  USE AUXIL       , ONLY:                                              &
                          MX1, MX2
  USE WAVEFIELD   , ONLY:                                              &
                          U, W, VU, VW,                                &
                          XXX, XZX, XZZ
  USE STRESSFIELD , ONLY:                                              &
                          TXX, TZXMW, TZZMW
  USE T_INTERFACES, ONLY:                                              &
                          HOM_S_INT, HOM_S_2ND, HOM_V_INT, HOM_V_2ND

  IMPLICIT NONE

  INTEGER, INTENT(IN) :: L


  CALL  HOM_S_INT  (     L = L  ,                                      &
                                    MX1T = MX1  ,   MX2T = MX2  ,      &
                        UT = U  ,     WT = W    ,                      &
                      XXXT = XXX, XZXT   = XZX  , XZZT   = XZZ  ,      &
                      TXXT = TXX, TZXMWT = TZXMW, TZZMWT = TZZMW  )

  CALL  HOM_S_2ND  (     L = L  ,                                      &
                       MXT = MX ,   MX1T = MX1  ,                      &
                        UT = U  ,     WT = W    ,                      &
                      XXXT = XXX, XZXT   = XZX  , XZZT   = XZZ  ,      &
                      TXXT = TXX, TZXMWT = TZXMW, TZZMWT = TZZMW  )

  CALL  HOM_V_INT  (     L = L  ,                                      &
                                                    MX2T = MX2  ,      &
                       VUT = VU ,    VWT = VW   ,                      &
                      TXXT = TXX, TZXMWT = TZXMW, TZZMWT = TZZMW  )

  CALL  HOM_V_2ND  (     L = L  ,                                      &
                                    MX1T = MX1  ,                      &
                       VUT = VU ,    VWT = VW   ,                      &
                      TXXT = TXX, TZXMWT = TZXMW, TZZMWT = TZZMW  )

END SUBROUTINE  HLINE_H
