!=======================================================================

SUBROUTINE  HLINE_I ( L )

  USE GRID_MEDIUM , ONLY:                                              &
                          JM,  LAM,  MU,  MUXZ,                        &
                              YLAM, YMU, YMUXZ,                        &
                              DENU, DENW
  USE CONTROL_DATA, ONLY:                                              &
                          MX
  USE AUXIL       , ONLY:                                              &
                          MX1, MX2
  USE WAVEFIELD   , ONLY:                                              &
                          U, W, VU, VW,                                &
                          XXX, XZX, XZZ
  USE STRESSFIELD , ONLY:                                              &
                          TXX, TZXMW, TZZMW
  USE T_INTERFACES, ONLY:                                              &
                          INH_S_INT, INH_S_2ND, INH_V_INT, INH_V_2ND

  IMPLICIT NONE

  INTEGER, INTENT(IN) :: L


  CALL  INH_S_INT  (     L = L   ,    JMT = JM   ,                     &
                                     MX1T = MX1  ,   MX2T = MX2  ,     &
                       MUT =  MU ,  MUXZT =  MUXZ,   LAMT =  LAM ,     &
                      YMUT = YMU , YMUXZT = YMUXZ,  YLAMT = YLAM ,     &
                        UT = U   ,     WT = W    ,                     &
                      XXXT = XXX , XZXT   = XZX  , XZZT   = XZZ  ,     &
                      TXXT = TXX , TZXMWT = TZXMW, TZZMWT = TZZMW  )

  CALL  INH_S_2ND  (     L = L   ,    JMT = JM   ,                     &
                       MXT = MX  ,   MX1T = MX1  ,                     &
                       MUT =  MU ,  MUXZT =  MUXZ,   LAMT =  LAM ,     &
                      YMUT = YMU , YMUXZT = YMUXZ,  YLAMT = YLAM ,     &
                        UT = U   ,     WT = W    ,                     &
                      XXXT = XXX , XZXT   = XZX  , XZZT   = XZZ  ,     &
                      TXXT = TXX , TZXMWT = TZXMW, TZZMWT = TZZMW  )

  CALL  INH_V_INT  (     L = L   ,    JMT = JM   ,                     &
                                                     MX2T = MX2  ,     &
                     DENUT = DENU,  DENWT = DENW ,                     &
                       VUT = VU  ,    VWT = VW   ,                     &
                      TXXT = TXX , TZXMWT = TZXMW, TZZMWT = TZZMW  )

  CALL  INH_V_2ND  (     L = L   ,    JMT = JM   ,                     &
                                     MX1T = MX1  ,                     &
                     DENUT = DENU,  DENWT = DENW ,                     &
                       VUT = VU  ,    VWT = VW   ,                     &
                      TXXT = TXX , TZXMWT = TZXMW, TZZMWT = TZZMW  )

END SUBROUTINE  HLINE_I
