!=======================================================================

SUBROUTINE  HLINE_MZ1

  USE CONTROL_DATA, ONLY:                                              &
                          MX, KEY_1D
  USE AUXIL       , ONLY:                                              &
                          MX1
  USE WAVEFIELD   , ONLY:                                              &
                          U, W, VU, VW,                                &
                          XXX, XZX, XZZ
  USE STRESSFIELD , ONLY:                                              &
                          TXX, TZXMW, TZZMW

  USE T_INTERFACES, ONLY:                                              &
                          MZ1_S_INT, MZ1_S_2ND, MZ1_V

  IMPLICIT NONE


  IF ( .NOT. KEY_1D ) THEN
    CALL  MZ1_S_INT  (               MX1T = MX1,                       &
                         UT = U  ,     WT = W    ,                     &
                       XXXT = XXX,                                     &
                       TXXT = TXX                  )
  END IF

  CALL  MZ1_S_2ND  (  MXT = MX ,  MX1T = MX1   ,                       &
                       UT = U  ,     WT = W    ,                       &
                                 XZXT   = XZX  , XZZT   = XZZ  ,       &
                                 TZXMWT = TZXMW, TZZMWT = TZZMW  )

  CALL  MZ1_V      (               MX1T = MX1,                         &
                      VUT = VU ,    VWT = VW   ,                       &
                     TXXT = TXX, TZXMWT = TZXMW, TZZMWT = TZZMW )

END SUBROUTINE  HLINE_MZ1
