!=======================================================================

SUBROUTINE  HOM_D_NR (L)

  USE CONTROL_DATA, ONLY:                                              &
                          MX
  USE AUXIL       , ONLY:                                              &
                          MX1, MX2,                                    &
                          UST02  , UST03   , UST04   ,                 &
                          WST01  , WST02   , WST03   ,                 &
                          UST0MX , UST0MX1 , UST0MX2 ,                 &
                          WST0MX , WST0MX1 , WST0MX2 ,                 &
                          USTM12 , USTM13  , USTM14  ,                 &
                          WSTM11 , WSTM12  , WSTM13  ,                 &
                          USTM1MX, USTM1MX1, USTM1MX2,                 &
                          WSTM1MX, WSTM1MX1, WSTM1MX2
  USE NONREF_BOUND, ONLY:                                              &
                          LLBT, LRBT,                                  &
                                  CALE01, CALE02,                      &
                          CALE10, CALE11, CALE12,                      &
                          CALE20, CALE21, CALE22,                      &
                                  CARI01, CARI02,                      &
                          CARI10, CARI11, CARI12,                      &
                          CARI20, CARI21, CARI22
  USE WAVEFIELD   , ONLY:                                              &
                          U, W
  USE T_INTERFACES, ONLY:                                              &
                          L_BOUND_SYM, R_BOUND_SYM

  IMPLICIT NONE

  INTEGER, INTENT (IN) :: L

!_____________________________________________________ LEFT BOUNDARY ___

  IF  ( .NOT. LLBT ) THEN

    CALL L_BOUND_SYM (L)

  ELSE

    U ( 2,L) =                       CALE01 * U     (  3,L)            &
                                   + CALE02 * U     (  4,L)            &
             + CALE10 * UST02  (L) + CALE11 * UST03 (    L)            &
                                   + CALE12 * UST04 (    L)            &
             + CALE20 * USTM12     + CALE21 * USTM13                   &
                                   + CALE22 * USTM14

    W ( 1,L) =                       CALE01 * W     (  2,L)            &
                                   + CALE02 * W     (  3,L)            &
             + CALE10 * WST01  (L) + CALE11 * WST02 (    L)            &
                                   + CALE12 * WST03 (    L)            &
             + CALE20 * WSTM11     + CALE21 * WSTM12                   &
                                   + CALE22 * WSTM13

  END IF
!____________________________________________________ RIGHT BOUNDARY ___

  IF  ( .NOT. LRBT ) THEN

    CALL R_BOUND_SYM (L)

  ELSE

    U (MX,L) =                       CARI01 * U       (MX1,L)          &
                                   + CARI02 * U       (MX2,L)          &
             + CARI10 * UST0MX (L) + CARI11 * UST0MX1 (    L)          &
                                   + CARI12 * UST0MX2 (    L)          &
             + CARI20 * USTM1MX    + CARI21 * USTM1MX1                 &
                                   + CARI22 * USTM1MX2

    W (MX,L) =                       CARI01 * W       (MX1,L)          &
                                   + CARI02 * W       (MX2,L)          &
             + CARI10 * WST0MX (L) + CARI11 * WST0MX1 (    L)          &
                                   + CARI12 * WST0MX2 (    L)          &
             + CARI20 * WSTM1MX    + CARI21 * WSTM1MX1                 &
                                   + CARI22 * WSTM1MX2

  END IF

END SUBROUTINE HOM_D_NR
