!=======================================================================

SUBROUTINE  HOM_D_NR_MZ

  USE PRECISION   , ONLY:                                              &
                          WP
  USE CONTROL_DATA, ONLY:                                              &
                          MZ
  USE AUXIL       , ONLY:                                              &
                          MX1, MZ1, MZ2,                               &
                          USTM1MZ2, WSTM1MZ2,                          &
                          USTM1MZ1, WSTM1MZ1,                          &
                          UST0MZ2 , WST0MZ2 ,                          &
                          UST0MZ1 , WST0MZ1 ,                          &
                          UST0MZ  , WST0MZ
  USE NONREF_BOUND, ONLY:                                              &
                                  CABT01, CABT02,                      &
                          CABT10, CABT11, CABT12,                      &
                          CABT20, CABT21, CABT22
  USE WAVEFIELD   , ONLY:                                              &
                          U, W

  IMPLICIT NONE

  INTEGER      :: I
  REAL    (WP) :: USTM1MZ, WSTM1MZ


  DO  I = 3, MX1

    USTM1MZ        = UST0MZ (I    )
    UST0MZ  (I   ) = U      (I, MZ)

    U       (I,MZ) =                        CABT01 * U        (I,MZ1)  &
                                          + CABT02 * U        (I,MZ2)  &
                   + CABT10 * UST0MZ  (I) + CABT11 * UST0MZ1  (I    )  &
                                          + CABT12 * UST0MZ2  (I    )  &
                   + CABT20 * USTM1MZ     + CABT21 * USTM1MZ1 (I    )  &
                                          + CABT22 * USTM1MZ2 (I    )
  END DO

  DO  I = 2, MX1

    WSTM1MZ        = WST0MZ (I    )
    WST0MZ  (I   ) = W      (I, MZ)

    W       (I,MZ) =                        CABT01 * W        (I,MZ1)  &
                                          + CABT02 * W        (I,MZ2)  &
                   + CABT10 * WST0MZ  (I) + CABT11 * WST0MZ1  (I    )  &
                                          + CABT12 * WST0MZ2  (I    )  &
                   + CABT20 * WSTM1MZ     + CABT21 * WSTM1MZ1 (I    )  &
                                          + CABT22 * WSTM1MZ2 (I    )

  END DO

END SUBROUTINE  HOM_D_NR_MZ
