!=======================================================================

SUBROUTINE  HOM_D_NR_MZ2

  USE CONTROL_DATA, ONLY:                                              &
                          MX
  USE AUXIL       , ONLY:                                              &
                          MX1, MX2, MZ2,                               &
                          USTM1MZ2, WSTM1MZ2,                          &
                          UST0MZ2 , WST0MZ2
  USE NONREF_BOUND, ONLY:                                              &
                          LLBT, LRBT,                                  &
                                  CALE01, CALE02,                      &
                          CALE10, CALE11, CALE12,                      &
                          CALE20, CALE21, CALE22,                      &
                                  CARI01, CARI02,                      &
                          CARI10, CARI11, CARI12,                      &
                          CARI20, CARI21, CARI22
  USE WAVEFIELD   , ONLY:                                              &
                          U, W
  USE T_INTERFACES, ONLY:                                              &
                          L_BOUND_SYM, R_BOUND_SYM

  IMPLICIT NONE

  INTEGER :: L

!_____________________________________________________ LEFT BOUNDARY ___

  L = MZ2

  IF  ( .NOT. LLBT ) THEN

    CALL L_BOUND_SYM (L)

  ELSE

    U ( 2,L) =                          CALE01 * U        (  3,L)      &
                                      + CALE02 * U        (  4,L)      &
             + CALE10 * UST0MZ2  ( 2) + CALE11 * UST0MZ2  (  3  )      &
                                      + CALE12 * UST0MZ2  (  4  )      &
             + CALE20 * USTM1MZ2 ( 2) + CALE21 * USTM1MZ2 (  3  )      &
                                      + CALE22 * USTM1MZ2 (  4  )

    W ( 1,L) =                          CALE01 * W        (  2,L)      &
                                      + CALE02 * W        (  3,L)      &
             + CALE10 * WST0MZ2  ( 1) + CALE11 * WST0MZ2  (  2  )      &
                                      + CALE12 * WST0MZ2  (  3  )      &
             + CALE20 * WSTM1MZ2 ( 1) + CALE21 * WSTM1MZ2 (  2  )      &
                                      + CALE22 * WSTM1MZ2 (  3  )

  END IF

!____________________________________________________ RIGHT BOUNDARY ___ 

  IF  ( .NOT. LRBT ) THEN

    CALL R_BOUND_SYM (L)

  ELSE

    U (MX,L) =                          CARI01 * U        (MX1,L)      &
                                      + CARI02 * U        (MX2,L)      &
             + CARI10 * UST0MZ2  (MX) + CARI11 * UST0MZ2  (MX1  )      &
                                      + CARI12 * UST0MZ2  (MX2  )      &
             + CARI20 * USTM1MZ2 (MX) + CARI21 * USTM1MZ2 (MX1  )      &
                                      + CARI22 * USTM1MZ2 (MX2  )

    W (MX,L) =                          CARI01 * W        (MX1,L)      &
                                      + CARI02 * W        (MX2,L)      &
             + CARI10 * WST0MZ2  (MX) + CARI11 * WST0MZ2  (MX1  )      &
                                      + CARI12 * WST0MZ2  (MX2  )      &
             + CARI20 * WSTM1MZ2 (MX) + CARI21 * WSTM1MZ2 (MX1  )      &
                                      + CARI22 * WSTM1MZ2 (MX2  )

  END IF

END SUBROUTINE  HOM_D_NR_MZ2
