!=======================================================================
! I=3 and MX1
! VUT (I,L) = vu (I,L)
! I=2 and MX1
! VWT (I,L) = vw (I,L)
SUBROUTINE  HOM_V_2ND  (    L,   MX1T,                                 &
                          VUT,    VWT,                                 &
                         TXXT, TZXMWT, TZZMWT )

  USE PRECISION   , ONLY:                                              &
                          WP
  USE AUXIL       , ONLY:                                              &
                          COD

  IMPLICIT NONE

  INTEGER     ,                  INTENT(IN)    ::                      &
                                                  L, MX1T
  REAL    (WP), DIMENSION(:)   , INTENT(IN)    ::                      &
                                                  TXXT
  REAL    (WP), DIMENSION(:,:) , INTENT(IN)    ::                      &
                                                  TZXMWT, TZZMWT
  REAL    (WP), DIMENSION(:,0:), INTENT(INOUT) ::                      &
                                                  VUT, VWT

  INTEGER :: I


  I = 2

  CALL  HOM_VWT_2ND

  I = 3

  CALL  HOM_VUT_2ND

  I = MX1T

  CALL  HOM_VWT_2ND
  CALL  HOM_VUT_2ND


CONTAINS

!-----------------------------------------------------------------------
  SUBROUTINE  HOM_VUT_2ND 

    INTEGER :: LZX2, LZX3

    LZX2 = MOD( (MOD(L+2,4) + 1), 4 ) + 1
    LZX3 = MOD( (MOD(L+2,4) + 2), 4 ) + 1

! vu (I,L) == vu (I,L+1/2)
    VUT (I,L) = VUT (I,L) + COD *                                      &
                  ( TXXT   (I  )      - TXXT   (I-1)                   &
                  + TZXMWT (I  ,LZX3) - TZXMWT (I  ,LZX2) )

  END SUBROUTINE  HOM_VUT_2ND

!-----------------------------------------------------------------------
  SUBROUTINE  HOM_VWT_2ND

    INTEGER :: LZZ2, LZZ3, LZX2

    LZZ2 = MOD( (MOD(L+1,4) + 2), 4 ) + 1
    LZZ3 = MOD( (MOD(L+1,4) + 3), 4 ) + 1

    LZX2 = MOD( (MOD(L+2,4) + 1), 4 ) + 1

! vw (I,L) == vw (I+1/2,L)
    VWT (I,L) = VWT (I,L) + COD *                                      &
                  ( TZZMWT (I  ,LZZ3) - TZZMWT (I  ,LZZ2)              &
                  + TZXMWT (I+1,LZX2) - TZXMWT (I  ,LZX2) )

  END SUBROUTINE  HOM_VWT_2ND

END SUBROUTINE  HOM_V_2ND
