!=======================================================================
! I=4,...,MX2
! VUT (I,L) = vu (I,L)
! I=3,...,MX2
! VWT (I,L) = vw (I,L)
SUBROUTINE  HOM_V_INT  (    L,   MX2T,                                 &
                          VUT,    VWT,                                 &
                         TXXT, TZXMWT, TZZMWT )

  USE PRECISION   , ONLY:                                              &
                          WP
  USE AUXIL       , ONLY:                                              &
                          COD, A, B

  IMPLICIT NONE

  INTEGER     ,                  INTENT(IN)    ::                      &
                                                  L, MX2T
  REAL    (WP), DIMENSION(:)   , INTENT(IN)    ::                      &
                                                  TXXT
  REAL    (WP), DIMENSION(:,:) , INTENT(IN)    ::                      &
                                                  TZXMWT, TZZMWT
  REAL    (WP), DIMENSION(:,0:), INTENT(INOUT) ::                      &
                                                  VUT, VWT

  INTEGER :: I, LZX1, LZX2, LZX3, LZX4, LZZ1, LZZ2, LZZ3, LZZ4 


!! calculation of vu (I,L) == vu (I,L+1/2)

  LZX1 = MOD( (MOD(L+2,4) + 0), 4 ) + 1
  LZX2 = MOD( (MOD(L+2,4) + 1), 4 ) + 1
  LZX3 = MOD( (MOD(L+2,4) + 2), 4 ) + 1
  LZX4 = MOD( (MOD(L+2,4) + 3), 4 ) + 1

  DO  I = 4, MX2T

! vu (I,L) == vu (I,L+1/2)
    VUT (I,L) = VUT (I,L) + COD *                                      &
                  ( A*( TXXT   (I+1)      - TXXT   (I-2)               &
                      + TZXMWT (I  ,LZX4) - TZXMWT (I  ,LZX1) )        &
                  + B*( TXXT   (I  )      - TXXT   (I-1)               &
                      + TZXMWT (I  ,LZX3) - TZXMWT (I  ,LZX2) ) )

  END DO


!! calculation of vw (I,L) == vw (I+1/2,L)

  LZZ1 = MOD( (MOD(L+1,4) + 1), 4 ) + 1
  LZZ2 = MOD( (MOD(L+1,4) + 2), 4 ) + 1
  LZZ3 = MOD( (MOD(L+1,4) + 3), 4 ) + 1
  LZZ4 = MOD( (MOD(L+1,4) + 4), 4 ) + 1

  DO  I = 3, MX2T

! vw (I,L) == vw (I+1/2,L)
    VWT (I,L) = VWT (I,L) + COD *                                      &
                  ( A*( TZZMWT (I  ,LZZ4) - TZZMWT (I  ,LZZ1)          &
                      + TZXMWT (I+2,LZX2) - TZXMWT (I-1,LZX2) )        &
                  + B*( TZZMWT (I  ,LZZ3) - TZZMWT (I  ,LZZ2)          &
                      + TZXMWT (I+1,LZX2) - TZXMWT (I  ,LZX2) ) )

  END DO

END SUBROUTINE  HOM_V_INT
