!=======================================================================

SUBROUTINE  INH_D_NR (L)

  USE CONTROL_DATA, ONLY:                                              &
                          MX
  USE AUXIL       , ONLY:                                              &
                          MX1, MX2,                                    &
                          UST02  , UST03   , UST04   ,                 &
                          WST01  , WST02   , WST03   ,                 &
                          UST0MX , UST0MX1 , UST0MX2 ,                 &
                          WST0MX , WST0MX1 , WST0MX2 ,                 &
                          USTM12 , USTM13  , USTM14  ,                 &
                          WSTM11 , WSTM12  , WSTM13  ,                 &
                          USTM1MX, USTM1MX1, USTM1MX2,                 &
                          WSTM1MX, WSTM1MX1, WSTM1MX2
  USE NONREF_BOUND, ONLY:                                              &
                          LLBT, LRBT,                                  &
                                 ALE01, ALE02,        ARI01, ARI02,    &
                          ALE10, ALE11, ALE12, ARI10, ARI11, ARI12,    &
                          ALE20, ALE21, ALE22, ARI20, ARI21, ARI22
  USE WAVEFIELD   , ONLY:                                              &
                          U, W
  USE T_INTERFACES, ONLY:                                              &
                          L_BOUND_SYM, R_BOUND_SYM

  IMPLICIT NONE

  INTEGER, INTENT (IN) :: L

!_____________________________________________________ LEFT BOUNDARY ___

  IF  ( .NOT. LLBT ) THEN

    CALL L_BOUND_SYM (L)

  ELSE

    U ( 2,L) =                          ALE01 (L) * U      (3,L)       &
                                      + ALE02 (L) * U      (4,L)       &
             + ALE10 (L) * UST02  (L) + ALE11 (L) * UST03  (  L)       &
                                      + ALE12 (L) * UST04  (  L)       &
             + ALE20 (L) * USTM12     + ALE21 (L) * USTM13             &
                                      + ALE22 (L) * USTM14

    W ( 1,L) =                          ALE01 (L) * W      (2,L)       &
                                      + ALE02 (L) * W      (3,L)       &
             + ALE10 (L) * WST01  (L) + ALE11 (L) * WST02  (  L)       &
                                      + ALE12 (L) * WST03  (  L)       &
             + ALE20 (L) * WSTM11     + ALE21 (L) * WSTM12             &
                                      + ALE22 (L) * WSTM13

  END IF
!____________________________________________________ RIGHT BOUNDARY ___

  IF  ( .NOT. LRBT ) THEN

    CALL R_BOUND_SYM (L)

  ELSE

    U (MX,L) =                           ARI01 (L) * U        (MX1,L)  &
                                       + ARI02 (L) * U        (MX2,L)  &
             + ARI10 (L) * UST0MX  (L) + ARI11 (L) * UST0MX1  (    L)  &
                                       + ARI12 (L) * UST0MX2  (    L)  &
             + ARI20 (L) * USTM1MX     + ARI21 (L) * USTM1MX1          &
                                       + ARI22 (L) * USTM1MX2

    W (MX,L) =                           ARI01 (L) * W        (MX1,L)  &
                                       + ARI02 (L) * W        (MX2,L)  &
             + ARI10 (L) * WST0MX  (L) + ARI11 (L) * WST0MX1  (    L)  &
                                       + ARI12 (L) * WST0MX2  (    L)  &
             + ARI20 (L) * WSTM1MX     + ARI21 (L) * WSTM1MX1          &
                                       + ARI22 (L) * WSTM1MX2

  END IF

END SUBROUTINE INH_D_NR
