!=======================================================================
! I=3 and MX1
! VUT (I,L) = vu (I,L)
! I=2 and MX1
! VWT (I,L) = vw (I,L)
SUBROUTINE  INH_V_2ND  (     L,    JMT,   MX1T,                        &
                         DENUT,  DENWT,                                &
                           VUT,    VWT,                                &
                          TXXT, TZXMWT, TZZMWT  )

  USE PRECISION, ONLY:                                                 &
                       WP, IK

  IMPLICIT NONE

  INTEGER     ,                  INTENT(IN)    ::                      &
                                                  L, MX1T
  INTEGER (IK), DIMENSION(:,0:), INTENT(IN)    ::                      &
                                                  JMT
  REAL    (WP), DIMENSION(:)   , INTENT(IN)    ::                      &
                                                  DENUT, DENWT
  REAL    (WP), DIMENSION(:)   , INTENT(IN)    ::                      &
                                                  TXXT
  REAL    (WP), DIMENSION(:,:) , INTENT(IN)    ::                      &
                                                  TZXMWT, TZZMWT
  REAL    (WP), DIMENSION(:,0:), INTENT(INOUT) ::                      &
                                                  VUT, VWT

  INTEGER :: I


  I = 2

  CALL  INH_VWT_2ND

  I = 3

  CALL  INH_VUT_2ND

  I = MX1T

  CALL  INH_VUT_2ND
  CALL  INH_VWT_2ND


CONTAINS

!-----------------------------------------------------------------------
  SUBROUTINE  INH_VUT_2ND

    INTEGER :: JM1, LZX2, LZX3

    LZX2 = MOD( (MOD(L+2,4) + 1), 4 ) + 1
    LZX3 = MOD( (MOD(L+2,4) + 2), 4 ) + 1

    JM1 = JMT (I,L)
! vu (I,L) == vu (I,L+1/2)
    VUT (I,L) = VUT (I,L) + DENUT (JM1) *                              &
                  ( TXXT   (I  )      - TXXT   (I-1)                   &
                  + TZXMWT (I  ,LZX3) - TZXMWT (I  ,LZX2) )

  END SUBROUTINE  INH_VUT_2ND

!-----------------------------------------------------------------------
  SUBROUTINE  INH_VWT_2ND

    INTEGER :: JM1, LZZ2, LZZ3, LZX2

    LZZ2 = MOD( (MOD(L+1,4) + 2), 4 ) + 1
    LZZ3 = MOD( (MOD(L+1,4) + 3), 4 ) + 1

    LZX2 = MOD( (MOD(L+2,4) + 1), 4 ) + 1

    JM1 = JMT (I,L)
! vw (I,L) == vw (I+1/2,L)
    VWT (I,L) = VWT (I,L) + DENWT (JM1) *                              &
                  ( TZZMWT (I  ,LZZ3) - TZZMWT (I  ,LZZ2)              &
                  + TZXMWT (I+1,LZX2) - TZXMWT (I  ,LZX2) )

  END SUBROUTINE  INH_VWT_2ND

END SUBROUTINE  INH_V_2ND
