!=======================================================================

PROGRAM DVS_2D

  USE INTERFACES, ONLY:                                                &
                        READ_OPEN, AUX1, READ_MODEL,                   &
                        ALLOC1, ALLOC2, START_DATA,                    &
                        PRE_NR_COEF0, PRE_NR_COEF1, PRE_SOURCE,        &
                        TIME_LOOP

  USE TIME      , ONLY:                                                &
                        TIME_BEGIN, TIME_END, DATE_TIME, BIG_BEN

!-----------------------------------------------------------------------

  IMPLICIT NONE

  CHARACTER(LEN=17) :: JOB_NAME

!-----------------------------------------------------------------------

  CALL CPU_TIME ( TIME_BEGIN )
  CALL DATE_AND_TIME ( BIG_BEN(1), BIG_BEN(2), BIG_BEN(3), DATE_TIME )
  WRITE (*,'(''Current time: '',I2,'':'',I2,'':'',F6.3)')              &
      DATE_TIME(5), DATE_TIME(6), DATE_TIME(7)+REAL(DATE_TIME(8)/1000.)


  OPEN  (10, FILE = 'HF2DDVS', STATUS='OLD')
  READ  (10,'(A)') JOB_NAME
  CLOSE (10)

  CALL  READ_OPEN ( JOB_NAME (1:LEN_TRIM(JOB_NAME)) )
                         PRINT *,  'read_open'
  CALL  AUX1
                         PRINT *,  'aux1'
  CALL  READ_MODEL
                         PRINT *,  'read_model'
  CALL  ALLOC1
                         PRINT *,  'alloc1'
  CALL  ALLOC2
                         PRINT *,  'alloc2'
  CALL  START_DATA( JOB_NAME (1:LEN_TRIM(JOB_NAME)) )
                         PRINT *,  'start_data'
  CALL  PRE_NR_COEF0
                         PRINT *,  'pre_nr_coef0'
  CALL  PRE_NR_COEF1
                         PRINT *,  'pre_nr_coef1'
  CALL  PRE_SOURCE
                         PRINT *,  'pre_source'
  CALL  TIME_LOOP
                         PRINT *,  'time_loop'

  CALL CPU_TIME ( TIME_END )
  CALL DATE_AND_TIME ( BIG_BEN(1), BIG_BEN(2), BIG_BEN(3), DATE_TIME )
  PRINT     *, 'CPU time: ', TIME_END - TIME_BEGIN, ' seconds'
  WRITE (*,'(''Current time: '',I2,'':'',I2,'':'',F6.3)')              &
      DATE_TIME(5), DATE_TIME(6), DATE_TIME(7)+REAL(DATE_TIME(8)/1000.)
  WRITE (11,'(F10.2,1X,I4,I3,I3,I5,3I3,I4)')                           &
             TIME_END - TIME_BEGIN, DATE_TIME

END PROGRAM DVS_2D
