!_______________________________________________________________________

MODULE T_INTERFACES

  INTERFACE

!___________________________________________________ VEL_ON_SOURCE _____

    SUBROUTINE      VEL_ON_SOURCE ( IT )
      INTEGER, INTENT (IN) :: IT
    END SUBROUTINE  VEL_ON_SOURCE

!__________________________________________________ VEL_OFF_SOURCE _____

    SUBROUTINE      VEL_OFF_SOURCE (IT)
      INTEGER, INTENT (IN) :: IT
    END SUBROUTINE  VEL_OFF_SOURCE

!_____________________________________________________ DISP_UPADTE _____

    SUBROUTINE      DISP_UPDATE    (IT)
      INTEGER, INTENT (IN) :: IT
    END SUBROUTINE  DISP_UPDATE

!_________________________________________________________ HLINE_0 _____

    SUBROUTINE      HLINE_0
    END SUBROUTINE  HLINE_0


    SUBROUTINE  FS0_S_INT  (  JMT,   MX1T,   MX2T,                     &
                              MUT,  MUXZT,   LAMT,                     &
                             YMUT, YMUXZT,  YLAMT,                     &
                               UT,     WT,                             &
                             XXXT, XZXT  , XZZT  ,                     &
                             TXXT, TZXMWT, TZZMWT  )
      USE PRECISION, ONLY: WP, IK
      IMPLICIT NONE
      INTEGER     ,                  INTENT(IN)    ::                  &
                                                  MX1T, MX2T
      INTEGER (IK), DIMENSION(:,0:), INTENT(IN)    ::                  &
                                                  JMT
      REAL    (WP), DIMENSION(:)   , INTENT(IN)    ::                  &
                                                   MUT,  MUXZT,  LAMT
      REAL    (WP), DIMENSION(:,:) , INTENT(IN)    ::                  &
                                                  YMUT, YMUXZT, YLAMT
      REAL    (WP), DIMENSION(:)   , INTENT(OUT)   ::                  &
                                                  TXXT
      REAL    (WP), DIMENSION(:,:) , INTENT(OUT)   ::                  &
                                                  TZXMWT, TZZMWT
      REAL    (WP), DIMENSION(:,0:), INTENT(IN)    ::                  &
                                                  UT, WT
      REAL    (WP), DIMENSION(:,0:), INTENT(INOUT) ::                  &
                                                  XXXT, XZXT, XZZT
    END SUBROUTINE  FS0_S_INT


    SUBROUTINE  FS0_S_2ND  (  JMT,   MX1T,                             &
                              MUT,          LAMT ,                     &
                             YMUT,         YLAMT ,                     &
                               UT,     WT,                             &
                             XXXT,         XZZT  ,                     &
                             TXXT,         TZZMWT  )
      USE PRECISION, ONLY: WP, IK
      IMPLICIT NONE
      INTEGER     ,                  INTENT(IN)    ::                  &
                                                  MX1T
      INTEGER (IK), DIMENSION(:,0:), INTENT(IN)    ::                  &
                                                  JMT
      REAL    (WP), DIMENSION(:)   , INTENT(IN)    ::                  &
                                                   MUT,  LAMT
      REAL    (WP), DIMENSION(:,:) , INTENT(IN)    ::                  &
                                                  YMUT, YLAMT
      REAL    (WP), DIMENSION(:)   , INTENT(OUT)   ::                  &
                                                  TXXT
      REAL    (WP), DIMENSION(:,:) , INTENT(OUT)   ::                  &
                                                  TZZMWT
      REAL    (WP), DIMENSION(:,0:), INTENT(IN)    ::                  &
                                                  UT, WT
      REAL    (WP), DIMENSION(:,0:), INTENT(INOUT) ::                  &
                                                  XXXT, XZZT
    END SUBROUTINE  FS0_S_2ND


    SUBROUTINE  FS0_V_INT  (   JMT,           MX2T,                    &
                             DENUT,  DENWT,                            &
                               VUT,    VWT,                            &
                              TXXT, TZXMWT, TZZMWT  )
      USE PRECISION, ONLY: WP, IK
      IMPLICIT NONE
      INTEGER     ,                  INTENT(IN)    ::                  &
                                                  MX2T
      INTEGER (IK), DIMENSION(:,0:), INTENT(IN)    ::                  &
                                                  JMT
      REAL    (WP), DIMENSION(:)   , INTENT(IN)    ::                  &
                                                  DENUT, DENWT
      REAL    (WP), DIMENSION(:)   , INTENT(IN)    ::                  &
                                                  TXXT
      REAL    (WP), DIMENSION(:,:) , INTENT(IN)    ::                  &
                                                  TZXMWT, TZZMWT
      REAL    (WP), DIMENSION(:,0:), INTENT(INOUT) ::                  &
                                                  VUT, VWT
    END SUBROUTINE  FS0_V_INT


    SUBROUTINE  FS0_V_2ND  (   JMT,   MX1T,                            &
                             DENUT,  DENWT,                            &
                               VUT,    VWT,                            &
                              TXXT, TZXMWT, TZZMWT  )
      USE PRECISION, ONLY: WP, IK
      IMPLICIT NONE
      INTEGER     ,                  INTENT(IN)    ::                  &
                                                  MX1T
      INTEGER (IK), DIMENSION(:,0:), INTENT(IN)    ::                  &
                                                  JMT
      REAL    (WP), DIMENSION(:)   , INTENT(IN)    ::                  &
                                                  DENUT, DENWT
      REAL    (WP), DIMENSION(:)   , INTENT(IN)    ::                  &
                                                  TXXT
      REAL    (WP), DIMENSION(:,:) , INTENT(IN)    ::                  &
                                                  TZXMWT, TZZMWT
      REAL    (WP), DIMENSION(:,0:), INTENT(INOUT) ::                  &
                                                  VUT, VWT
    END SUBROUTINE  FS0_V_2ND

!_________________________________________________________ HLINE_1 _____

    SUBROUTINE      HLINE_1
    END SUBROUTINE  HLINE_1


    SUBROUTINE  FS1_S_INT  (  JMT,           MX2T,                     &
                              MUT,           LAMT,                     &
                             YMUT,          YLAMT,                     &
                               UT,     WT,                             &
                             XXXT,                                     &
                             TXXT                  )
      USE PRECISION, ONLY: WP, IK
      IMPLICIT NONE
      INTEGER     ,                  INTENT(IN)    ::                  &
                                                  MX2T
      INTEGER (IK), DIMENSION(:,0:), INTENT(IN)    ::                  &
                                                  JMT
      REAL    (WP), DIMENSION(:)   , INTENT(IN)    ::                  &
                                                   MUT,  LAMT
      REAL    (WP), DIMENSION(:,:) , INTENT(IN)    ::                  &
                                                  YMUT, YLAMT
      REAL    (WP), DIMENSION(:)   , INTENT(OUT)   ::                  &
                                                  TXXT
      REAL    (WP), DIMENSION(:,0:), INTENT(IN)    ::                  &
                                                  UT, WT
      REAL    (WP), DIMENSION(:,0:), INTENT(INOUT) ::                  &
                                                  XXXT
    END SUBROUTINE  FS1_S_INT


    SUBROUTINE  FS1_S_2ND  (  JMT,    MXT,   MX1T,                     &
                              MUT,  MUXZT,   LAMT,                     &
                             YMUT, YMUXZT,  YLAMT,                     &
                               UT,     WT,                             &
                             XXXT, XZXT  ,                             &
                             TXXT, TZXMWT          )
      USE PRECISION, ONLY: WP, IK
      IMPLICIT NONE
      INTEGER     ,                  INTENT(IN)    ::                  &
                                                  MXT, MX1T
      INTEGER (IK), DIMENSION(:,0:), INTENT(IN)    ::                  &
                                                  JMT
      REAL    (WP), DIMENSION(:)   , INTENT(IN)    ::                  &
                                                   MUT,  LAMT,  MUXZT
      REAL    (WP), DIMENSION(:,:) , INTENT(IN)    ::                  &
                                                  YMUT, YLAMT, YMUXZT
      REAL    (WP), DIMENSION(:)   , INTENT(OUT)   ::                  &
                                                  TXXT
      REAL    (WP), DIMENSION(:,:) , INTENT(OUT)   ::                  &
                                                  TZXMWT
      REAL    (WP), DIMENSION(:,0:), INTENT(IN)    ::                  &
                                                  UT, WT
      REAL    (WP), DIMENSION(:,0:), INTENT(INOUT) ::                  &
                                                  XXXT, XZXT
    END SUBROUTINE  FS1_S_2ND


    SUBROUTINE  FS1_V_INT  (   JMT,   MX2T,                            &
                             DENUT,  DENWT,                            &
                               VUT,    VWT,                            &
                              TXXT, TZXMWT, TZZMWT )
      USE PRECISION, ONLY: WP, IK
      IMPLICIT NONE
      INTEGER     ,                  INTENT(IN)    ::                  &
                                                  MX2T
      INTEGER (IK), DIMENSION(:,0:), INTENT(IN)    ::                  &
                                                  JMT
      REAL    (WP), DIMENSION(:)   , INTENT(IN)    ::                  &
                                                  DENUT, DENWT
      REAL    (WP), DIMENSION(:)   , INTENT(IN)    ::                  &
                                                  TXXT
      REAL    (WP), DIMENSION(:,:) , INTENT(IN)    ::                  &
                                                  TZXMWT, TZZMWT
      REAL    (WP), DIMENSION(:,0:), INTENT(INOUT) ::                  &
                                                  VUT, VWT
    END SUBROUTINE  FS1_V_INT


    SUBROUTINE  FS1_V_2ND  (   JMT,   MX1T,                            &
                             DENUT,  DENWT,                            &
                               VUT,    VWT,                            &
                              TXXT, TZXMWT, TZZMWT )
      USE PRECISION, ONLY: WP, IK
      IMPLICIT NONE
      INTEGER     ,                  INTENT(IN)    ::                  &
                                                   MX1T
      INTEGER (IK), DIMENSION(:,0:), INTENT(IN)    ::                  &
                                                   JMT
      REAL    (WP), DIMENSION(:)   , INTENT(IN)    ::                  &
                                                   DENUT, DENWT
      REAL    (WP), DIMENSION(:)   , INTENT(IN)    ::                  &
                                                  TXXT
      REAL    (WP), DIMENSION(:,:) , INTENT(IN)    ::                  &
                                                  TZXMWT, TZZMWT
      REAL    (WP), DIMENSION(:,0:), INTENT(INOUT) ::                  &
                                                  VUT, VWT
    END SUBROUTINE  FS1_V_2ND

!_________________________________________________________ HLINE_2 _____

    SUBROUTINE      HLINE_2
    END SUBROUTINE  HLINE_2


    SUBROUTINE  FS2_S_INT  (  JMT,           MX2T,                     &
                              MUT,           LAMT,                     &
                             YMUT,          YLAMT,                     &
                               UT,     WT,                             &
                             XXXT,                                     &
                             TXXT                  )
      USE PRECISION, ONLY: WP, IK
      IMPLICIT NONE
      INTEGER     ,                  INTENT(IN)    ::                  &
                                                  MX2T
      INTEGER (IK), DIMENSION(:,0:), INTENT(IN)    ::                  &
                                                  JMT
      REAL    (WP), DIMENSION(:)   , INTENT(IN)    ::                  &
                                                   MUT,  LAMT
      REAL    (WP), DIMENSION(:,:) , INTENT(IN)    ::                  &
                                                  YMUT, YLAMT
      REAL    (WP), DIMENSION(:)   , INTENT(OUT)   ::                  &
                                                  TXXT
      REAL    (WP), DIMENSION(:,0:), INTENT(IN)    ::                  &
                                                  UT, WT
      REAL    (WP), DIMENSION(:,0:), INTENT(INOUT) ::                  &
                                                  XXXT
    END SUBROUTINE  FS2_S_INT


    SUBROUTINE  FS2_S_2ND  (  JMT,    MXT,   MX1T,                     &
                              MUT,  MUXZT,   LAMT,                     &
                             YMUT, YMUXZT,  YLAMT,                     &
                               UT,     WT,                             &
                             XXXT, XZXT  , XZZT  ,                     &
                             TXXT, TZXMWT, TZZMWT  )
      USE PRECISION, ONLY: WP, IK
      IMPLICIT NONE
      INTEGER     ,                  INTENT(IN)    ::                  &
                                                  MXT, MX1T
      INTEGER (IK), DIMENSION(:,0:), INTENT(IN)    ::                  &
                                                  JMT
      REAL    (WP), DIMENSION(:)   , INTENT(IN)    ::                  &
                                                   MUT,  LAMT,  MUXZT
      REAL    (WP), DIMENSION(:,:) , INTENT(IN)    ::                  &
                                                  YMUT, YLAMT, YMUXZT
      REAL    (WP), DIMENSION(:)   , INTENT(OUT)   ::                  &
                                                  TXXT
      REAL    (WP), DIMENSION(:,:) , INTENT(OUT)   ::                  &
                                                  TZXMWT, TZZMWT
      REAL    (WP), DIMENSION(:,0:), INTENT(IN)    ::                  &
                                                  UT, WT
      REAL    (WP), DIMENSION(:,0:), INTENT(INOUT) ::                  &
                                                  XXXT, XZXT, XZZT
    END SUBROUTINE  FS2_S_2ND


    SUBROUTINE  FS2_V_INT  (   JMT,   MX2T,                            &
                             DENUT,  DENWT,                            &
                               VUT,    VWT,                            &
                              TXXT, TZXMWT, TZZMWT )
      USE PRECISION, ONLY: WP, IK
      IMPLICIT NONE
      INTEGER     ,                  INTENT(IN)    ::                  &
                                                  MX2T
      INTEGER (IK), DIMENSION(:,0:), INTENT(IN)    ::                  &
                                                  JMT
      REAL    (WP), DIMENSION(:)   , INTENT(IN)    ::                  &
                                                  DENUT, DENWT
      REAL    (WP), DIMENSION(:)   , INTENT(IN)    ::                  &
                                                  TXXT
      REAL    (WP), DIMENSION(:,:) , INTENT(IN)    ::                  &
                                                  TZXMWT, TZZMWT
      REAL    (WP), DIMENSION(:,0:), INTENT(INOUT) ::                  &
                                                  VUT, VWT
    END SUBROUTINE  FS2_V_INT


    SUBROUTINE  FS2_V_2ND  (   JMT,   MX1T,                            &
                             DENUT,  DENWT,                            &
                               VUT,    VWT,                            &
                              TXXT, TZXMWT, TZZMWT )
      USE PRECISION, ONLY: WP, IK
      IMPLICIT NONE
      INTEGER     ,                  INTENT(IN)    ::                  &
                                                   MX1T
      INTEGER (IK), DIMENSION(:,0:), INTENT(IN)    ::                  &
                                                   JMT
      REAL    (WP), DIMENSION(:)   , INTENT(IN)    ::                  &
                                                   DENUT, DENWT
      REAL    (WP), DIMENSION(:)   , INTENT(IN)    ::                  &
                                                  TXXT
      REAL    (WP), DIMENSION(:,:) , INTENT(IN)    ::                  &
                                                  TZXMWT, TZZMWT
      REAL    (WP), DIMENSION(:,0:), INTENT(INOUT) ::                  &
                                                  VUT, VWT
    END SUBROUTINE  FS2_V_2ND

!_________________________________________________________ HLINE_I _____

    SUBROUTINE      HLINE_I  ( L )
      INTEGER, INTENT (IN) ::  L
    END SUBROUTINE  HLINE_I


    SUBROUTINE  INH_S_INT  (    L,    JMT,   MX1T, MX2T,               &
                              MUT,  MUXZT,   LAMT,                     &
                             YMUT, YMUXZT,  YLAMT,                     &
                               UT,     WT,                             &
                             XXXT, XZXT  , XZZT  ,                     &
                             TXXT, TZXMWT, TZZMWT        )
      USE PRECISION, ONLY: WP, IK
      IMPLICIT NONE
      INTEGER     ,                  INTENT(IN)    ::                  &
                                                  L, MX1T, MX2T
      INTEGER (IK), DIMENSION(:,0:), INTENT(IN)    ::                  &
                                                  JMT
      REAL    (WP), DIMENSION(:)   , INTENT(IN)    ::                  &
                                                   MUT,  LAMT,  MUXZT
      REAL    (WP), DIMENSION(:,:) , INTENT(IN)    ::                  &
                                                  YMUT, YLAMT, YMUXZT
      REAL    (WP), DIMENSION(:)   , INTENT(OUT)   ::                  &
                                                  TXXT
      REAL    (WP), DIMENSION(:,:) , INTENT(OUT)   ::                  &
                                                  TZXMWT, TZZMWT
      REAL    (WP), DIMENSION(:,0:), INTENT(IN)    ::                  &
                                                  UT, WT
      REAL    (WP), DIMENSION(:,0:), INTENT(INOUT) ::                  &
                                                  XXXT, XZXT, XZZT
    END SUBROUTINE  INH_S_INT


    SUBROUTINE  INH_S_2ND  (    L,    JMT,    MXT, MX1T,               &
                              MUT,  MUXZT,   LAMT,                     &
                             YMUT, YMUXZT,  YLAMT,                     &
                               UT,     WT,                             &
                             XXXT, XZXT  , XZZT  ,                     &
                             TXXT, TZXMWT, TZZMWT        )
      USE PRECISION, ONLY: WP, IK
      IMPLICIT NONE
      INTEGER     ,                  INTENT(IN)    ::                  &
                                                  L, MXT, MX1T
      INTEGER (IK), DIMENSION(:,0:), INTENT(IN)    ::                  &
                                                  JMT
      REAL    (WP), DIMENSION(:)   , INTENT(IN)    ::                  &
                                                   MUT,  LAMT,  MUXZT
      REAL    (WP), DIMENSION(:,:) , INTENT(IN)    ::                  &
                                                  YMUT, YLAMT, YMUXZT
      REAL    (WP), DIMENSION(:)   , INTENT(OUT)   ::                  &
                                                  TXXT
      REAL    (WP), DIMENSION(:,:) , INTENT(OUT)   ::                  &
                                                  TZXMWT, TZZMWT
      REAL    (WP), DIMENSION(:,0:), INTENT(IN)    ::                  &
                                                  UT, WT
      REAL    (WP), DIMENSION(:,0:), INTENT(INOUT) ::                  &
                                                  XXXT, XZXT, XZZT
    END SUBROUTINE  INH_S_2ND


    SUBROUTINE  INH_V_INT  (     L,    JMT,   MX2T,                    &
                             DENUT,  DENWT,                            &
                               VUT,    VWT,                            &
                              TXXT, TZXMWT, TZZMWT  )
      USE PRECISION, ONLY: WP, IK
      IMPLICIT NONE
      INTEGER     ,                  INTENT(IN)    ::                  &
                                                  L, MX2T
      INTEGER (IK), DIMENSION(:,0:), INTENT(IN)    ::                  &
                                                  JMT
      REAL    (WP), DIMENSION(:)   , INTENT(IN)    ::                  &
                                                  DENUT, DENWT
      REAL    (WP), DIMENSION(:)   , INTENT(IN)    ::                  &
                                                  TXXT
      REAL    (WP), DIMENSION(:,:) , INTENT(IN)    ::                  &
                                                  TZXMWT, TZZMWT
      REAL    (WP), DIMENSION(:,0:), INTENT(INOUT) ::                  &
                                                  VUT, VWT
    END SUBROUTINE  INH_V_INT


    SUBROUTINE  INH_V_2ND  (     L,    JMT,   MX1T,                    &
                             DENUT,  DENWT,                            &
                               VUT,    VWT,                            &
                              TXXT, TZXMWT, TZZMWT  )
      USE PRECISION, ONLY: WP, IK
      IMPLICIT NONE
      INTEGER     ,                  INTENT(IN)    ::                  &
                                                  L, MX1T
      INTEGER (IK), DIMENSION(:,0:), INTENT(IN)    ::                  &
                                                  JMT
      REAL    (WP), DIMENSION(:)   , INTENT(IN)    ::                  &
                                                  DENUT, DENWT
      REAL    (WP), DIMENSION(:)   , INTENT(IN)    ::                  &
                                                  TXXT
      REAL    (WP), DIMENSION(:,:) , INTENT(IN)    ::                  &
                                                  TZXMWT, TZZMWT
      REAL    (WP), DIMENSION(:,0:), INTENT(INOUT) ::                  &
                                                  VUT, VWT
    END SUBROUTINE  INH_V_2ND

!_________________________________________________________ HLINE_H _____

    SUBROUTINE      HLINE_H  ( L )
      INTEGER, INTENT (IN) ::  L
    END SUBROUTINE  HLINE_H


    SUBROUTINE  HOM_S_INT  (    L,   MX1T,   MX2T,                     &
                               UT,     WT,                             &
                             XXXT, XZXT  , XZZT  ,                     &
                             TXXT, TZXMWT, TZZMWT  )
      USE PRECISION, ONLY: WP
      IMPLICIT NONE
      INTEGER     ,                  INTENT(IN)    ::                  &
                                                  L, MX1T, MX2T
      REAL    (WP), DIMENSION(:)   , INTENT(OUT)   ::                  &
                                                  TXXT
      REAL    (WP), DIMENSION(:,:) , INTENT(OUT)   ::                  &
                                                  TZXMWT, TZZMWT
      REAL    (WP), DIMENSION(:,0:), INTENT(IN)    ::                  &
                                                  UT, WT
      REAL    (WP), DIMENSION(:,0:), INTENT(INOUT) ::                  &
                                                  XXXT, XZXT, XZZT
    END SUBROUTINE  HOM_S_INT


    SUBROUTINE  HOM_S_2ND  (    L,    MXT,   MX1T,                     &
                               UT,     WT,                             &
                             XXXT, XZXT  , XZZT  ,                     &
                             TXXT, TZXMWT, TZZMWT  )
      USE PRECISION, ONLY: WP
      IMPLICIT NONE
      INTEGER     ,                  INTENT(IN)    ::                  &
                                                  L, MXT, MX1T
      REAL    (WP), DIMENSION(:)   , INTENT(OUT)   ::                  &
                                                  TXXT
      REAL    (WP), DIMENSION(:,:) , INTENT(OUT)   ::                  &
                                                  TZXMWT, TZZMWT
      REAL    (WP), DIMENSION(:,0:), INTENT(IN)    ::                  &
                                                  UT, WT
      REAL    (WP), DIMENSION(:,0:), INTENT(INOUT) ::                  &
                                                  XXXT, XZXT, XZZT
    END SUBROUTINE  HOM_S_2ND


    SUBROUTINE  HOM_V_INT  (    L,   MX2T,                             &
                              VUT,    VWT,                             &
                             TXXT, TZXMWT, TZZMWT )
      USE PRECISION, ONLY: WP
      IMPLICIT NONE
      INTEGER     ,                  INTENT(IN)    ::                  &
                                                  L, MX2T
      REAL    (WP), DIMENSION(:)   , INTENT(IN)    ::                  &
                                                  TXXT
      REAL    (WP), DIMENSION(:,:) , INTENT(IN)    ::                  &
                                                  TZXMWT, TZZMWT
      REAL    (WP), DIMENSION(:,0:), INTENT(INOUT) ::                  &
                                                  VUT, VWT
    END SUBROUTINE  HOM_V_INT


    SUBROUTINE  HOM_V_2ND  (    L,   MX1T,                             &
                              VUT,    VWT,                             &
                             TXXT, TZXMWT, TZZMWT )
      USE PRECISION, ONLY: WP
      IMPLICIT NONE
      INTEGER     ,                  INTENT(IN)    ::                  &
                                                  L, MX1T
      REAL    (WP), DIMENSION(:)   , INTENT(IN)    ::                  &
                                                  TXXT
      REAL    (WP), DIMENSION(:,:) , INTENT(IN)    ::                  &
                                                  TZXMWT, TZZMWT
      REAL    (WP), DIMENSION(:,0:), INTENT(INOUT) ::                  &
                                                  VUT, VWT
    END SUBROUTINE  HOM_V_2ND

!_______________________________________________________ HLINE_PW ______

    SUBROUTINE      HLINE_PW
    END SUBROUTINE  HLINE_PW


    SUBROUTINE  PW_S_INT  (         MX1T,   MX2T,                      &
                               UT,    WT,                              &
                                  XZXT  , XZZT  ,                      &
                                  TZXMWT, TZZMWT  )
      USE PRECISION, ONLY: WP
      IMPLICIT NONE
      INTEGER     ,                  INTENT(IN)    ::                  &
                                                  MX1T, MX2T
      REAL    (WP), DIMENSION(:,:) , INTENT(OUT) ::                    &
                                                  TZXMWT, TZZMWT
      REAL    (WP), DIMENSION(:,0:), INTENT(IN) ::                     &
                                                  UT, WT
      REAL    (WP), DIMENSION(:,0:), INTENT(INOUT) ::                  &
                                                  XZXT  , XZZT
    END SUBROUTINE PW_S_INT


    SUBROUTINE  PW_S_2ND  (         MX1T,                              &
                               UT,    WT,                              &
                                          XZZT  ,                      &
                                          TZZMWT  )
      USE PRECISION, ONLY: WP
      IMPLICIT NONE
      INTEGER     ,                  INTENT(IN)    ::                  &
                                                  MX1T
      REAL    (WP), DIMENSION(:,:) , INTENT(OUT) ::                    &
                                                  TZZMWT
      REAL    (WP), DIMENSION(:,0:), INTENT(IN) ::                     &
                                                  UT, WT
      REAL    (WP), DIMENSION(:,0:), INTENT(INOUT) ::                  &
                                                  XZZT
    END SUBROUTINE PW_S_2ND

!_______________________________________________________ HLINE_MZ2 _____

    SUBROUTINE      HLINE_MZ2
    END SUBROUTINE  HLINE_MZ2


    SUBROUTINE  MZ2_S_INT  (    L,   MX1T,   MX2T,                     &
                               UT,     WT,                             &
                             XXXT, XZXT  , XZZT  ,                     &
                             TXXT, TZXMWT, TZZMWT  )
      USE PRECISION, ONLY: WP
      IMPLICIT NONE
      INTEGER     ,                  INTENT(IN)    ::                  &
                                                  L, MX1T, MX2T
      REAL    (WP), DIMENSION(:)   , INTENT(OUT)   ::                  &
                                                  TXXT
      REAL    (WP), DIMENSION(:,:) , INTENT(OUT)   ::                  &
                                                  TZXMWT, TZZMWT
      REAL    (WP), DIMENSION(:,0:), INTENT(IN)    ::                  &
                                                  UT, WT
      REAL    (WP), DIMENSION(:,0:), INTENT(INOUT) ::                  &
                                                  XXXT, XZXT, XZZT
    END SUBROUTINE  MZ2_S_INT

!_______________________________________________________ HLINE_MZ1 _____

    SUBROUTINE      HLINE_MZ1
    END SUBROUTINE  HLINE_MZ1


    SUBROUTINE  MZ1_S_INT  ( MX1T, UT, WT, XXXT, TXXT )
      USE PRECISION, ONLY: WP
      IMPLICIT NONE
      INTEGER     ,                  INTENT(IN)    ::                  &
                                                  MX1T
      REAL    (WP), DIMENSION(:)   , INTENT(OUT)   ::                  &
                                                  TXXT
      REAL    (WP), DIMENSION(:,0:), INTENT(IN)    ::                  &
                                                  UT, WT
      REAL    (WP), DIMENSION(:,0:), INTENT(INOUT) ::                  &
                                                  XXXT
    END SUBROUTINE  MZ1_S_INT


    SUBROUTINE  MZ1_S_2ND  ( MXT,   MX1T,                              &
                              UT,     WT,                              &
                                  XZXT  , XZZT  ,                      &
                                  TZXMWT, TZZMWT  )
      USE PRECISION, ONLY: WP
      IMPLICIT NONE
      INTEGER     ,                  INTENT(IN)    ::                  &
                                                  MXT, MX1T
      REAL    (WP), DIMENSION(:,:) , INTENT(OUT)   ::                  &
                                                  TZXMWT, TZZMWT
      REAL    (WP), DIMENSION(:,0:), INTENT(IN)    ::                  &
                                                  UT, WT
      REAL    (WP), DIMENSION(:,0:), INTENT(INOUT) ::                  &
                                                  XZXT, XZZT
    END SUBROUTINE  MZ1_S_2ND


    SUBROUTINE  MZ1_V      ( MX1T,    VUT,    VWT,                     &
                             TXXT, TZXMWT, TZZMWT  )
      USE PRECISION, ONLY: WP
      IMPLICIT NONE
      INTEGER     ,                  INTENT(IN)    ::                  &
                                                  MX1T
      REAL    (WP), DIMENSION(:)   , INTENT(IN)    ::                  &
                                                  TXXT
      REAL    (WP), DIMENSION(:,:) , INTENT(IN)    ::                  &
                                                  TZXMWT, TZZMWT
      REAL    (WP), DIMENSION(:,0:), INTENT(INOUT) ::                  &
                                                  VUT, VWT
    END SUBROUTINE  MZ1_V

!_____________________________________________________________ REC _____

    SUBROUTINE      REC  ( T, UT, WT, OP_F1, OP_F2 )

      USE PRECISION, ONLY: WP
      IMPLICIT NONE
      INTEGER     ,                 INTENT(IN) :: OP_F1, OP_F2
      REAL    (WP),                 INTENT(IN) :: T
      REAL    (WP), DIMENSION(:,:), INTENT(IN) :: UT, WT

    END SUBROUTINE  REC

!____________________________________________________________ REC0 _____

    SUBROUTINE      REC0 (T, UT, WT, OP_F3, OP_F4)

      USE PRECISION, ONLY: WP
      IMPLICIT NONE
      INTEGER     ,                 INTENT(IN) :: OP_F3, OP_F4
      REAL    (WP),                 INTENT(IN) :: T
      REAL    (WP), DIMENSION(:,:), INTENT(IN) :: UT, WT

    END SUBROUTINE  REC0

!____________________________________________________________ SNAP _____

    SUBROUTINE      SNAP  ( NUMSNAP, UT, WT, SN_BASE_1, SN_BASE_2 )

      USE PRECISION, ONLY: WP
      IMPLICIT NONE
      CHARACTER(LEN=8),                 INTENT(IN) ::                  &
                                              SN_BASE_1, SN_BASE_2
      INTEGER         ,                 INTENT(IN) :: NUMSNAP
      REAL    (WP)    , DIMENSION(:,:), INTENT(IN) :: UT, WT

    END SUBROUTINE  SNAP

!_________________________________________________________ STO_BOU _____

    SUBROUTINE      STO_BOU  ( L )
      INTEGER, INTENT (IN) :: L
    END SUBROUTINE  STO_BOU

!________________________________________________________ DISP_INT _____

    SUBROUTINE      DISP_INT ( L )
      INTEGER, INTENT (IN) :: L
    END SUBROUTINE  DISP_INT

!________________________________________________________ INH_D_NR _____

    SUBROUTINE      INH_D_NR ( L )
      INTEGER, INTENT (IN) :: L
    END SUBROUTINE  INH_D_NR

!________________________________________________________ HOM_D_NR _____

    SUBROUTINE      HOM_D_NR ( L )
      INTEGER, INTENT (IN) :: L
    END SUBROUTINE  HOM_D_NR

!_____________________________________________________ STO_BOU_MZ2 _____

    SUBROUTINE      STO_BOU_MZ2
    END SUBROUTINE  STO_BOU_MZ2

!____________________________________________________ HOM_D_NR_MZ2 _____

    SUBROUTINE      HOM_D_NR_MZ2
    END SUBROUTINE  HOM_D_NR_MZ2

!_____________________________________________________ STO_BOU_MZ1 _____

    SUBROUTINE      STO_BOU_MZ1
    END SUBROUTINE  STO_BOU_MZ1

!____________________________________________________ HOM_D_NR_MZ1 _____

    SUBROUTINE      HOM_D_NR_MZ1
    END SUBROUTINE  HOM_D_NR_MZ1

!_____________________________________________________ HOM_D_NR_MZ _____

    SUBROUTINE      HOM_D_NR_MZ
    END SUBROUTINE  HOM_D_NR_MZ

!_____________________________________________________ L_BOUND_SYM _____

    SUBROUTINE      L_BOUND_SYM ( L )
      INTEGER, INTENT(IN):: L
    END SUBROUTINE  L_BOUND_SYM

!_____________________________________________________ L_BOUND_SYM _____

    SUBROUTINE      R_BOUND_SYM ( L )
      INTEGER, INTENT(IN):: L
    END SUBROUTINE  R_BOUND_SYM

!______________________________________________________ RECORD_ALL _____

    SUBROUTINE      RECORD_ALL
    END SUBROUTINE  RECORD_ALL

!_____________________________________________________ CLOSE_FILES _____

    SUBROUTINE      CLOSE_FILES
    END SUBROUTINE  CLOSE_FILES


!___________________________________________________ FUNCTION  IND _____

    FUNCTION      IND (I,L)
      INTEGER, INTENT(IN ) :: I,L
      INTEGER              :: IND
    END FUNCTION  IND

!____________________________________________________ FUNCTION  FS _____

    FUNCTION      FS (T)
      USE PRECISION, ONLY: WP
      IMPLICIT NONE
      REAL (WP), INTENT (IN) :: T
      REAL (WP)              :: FS
    END FUNCTION  FS

  END INTERFACE

END MODULE T_INTERFACES
