!=======================================================================
! I=2,..., MX1
!    XXXT   (I,L   ) =  xi^xx (I,MZ1)
!    TXXT   (I)      = tau_xx (I,MZ1)
SUBROUTINE  MZ1_S_INT  ( MX1T, UT, WT, XXXT, TXXT )

  USE PRECISION   , ONLY:                                              &
                          WP
  USE GRID_MEDIUM , ONLY:                                              &
                          COLAM, COL2M, CYLAM, CYL2M
  USE AUXIL       , ONLY:                                              &
                          OTA, MZ1
  USE T_INTERFACES, ONLY:                                              &
                          IND

  IMPLICIT NONE

  INTEGER     ,                  INTENT(IN)    ::                      &
                                                  MX1T
  REAL    (WP), DIMENSION(:)   , INTENT(OUT)   ::                      &
                                                  TXXT
  REAL    (WP), DIMENSION(:,0:), INTENT(IN)    ::                      &
                                                  UT, WT
  REAL    (WP), DIMENSION(:,0:), INTENT(INOUT) ::                      &
                                                  XXXT

  INTEGER      :: I, IO, L, LP1
  REAL    (WP) :: OT, ET1, ET2, XT, XT0


  L   = MZ1

  LP1 = L + 1

  DO  I = 2, MX1T

! coarse graining
    IO  = IND (I,L)
    OT  = OTA (IO)
! u_x (I,L) == u_x (I+1/2,L+1/2)
    ET1 = UT (I+1,L  ) - UT (I  ,L  )
! w_z (I,L) == w_z (I+1/2,L+1/2)
    ET2 = WT (I  ,LP1) - WT (I  ,L  )
! xi^xx (I,L) == xi^xx (I+1/2,L+1/2)
    XT0 = XXXT (I,L)
    XT  = OT*XT0 +  CYL2M (IO) * ET1 + CYLAM (IO) * ET2
    XXXT (I,L) = XT
! tau_xx (I) == tau_xx (I+1/2,L+1/2)
    TXXT (I)   =  COL2M * ET1 + COLAM * ET2 - ( XT + XT0 )*0.5_WP

  END DO

END SUBROUTINE  MZ1_S_INT
