!=======================================================================
! I=3,..., MX1
! VUT (I,L) = vu (I,MZ1)
! I=2,..., MX1
! VWT (I,L) = vw (I,MZ1)
SUBROUTINE  MZ1_V  ( MX1T,    VUT,    VWT,                             &
                     TXXT, TZXMWT, TZZMWT  )

  USE PRECISION   , ONLY:                                              &
                          WP
  USE AUXIL       , ONLY:                                              &
                          COD, MZ1

  IMPLICIT NONE

  INTEGER     ,                  INTENT(IN)    ::                      &
                                                  MX1T
  REAL    (WP), DIMENSION(:)   , INTENT(IN)    ::                      &
                                                  TXXT
  REAL    (WP), DIMENSION(:,:) , INTENT(IN)    ::                      &
                                                  TZXMWT, TZZMWT
  REAL    (WP), DIMENSION(:,0:), INTENT(INOUT) ::                      &
                                                  VUT, VWT

  INTEGER :: I, L, LZX2, LZX3, LZZ2, LZZ3


  L = MZ1

! vu (I,L) == vu (I,L+1/2)

  LZX2 = MOD( (MOD(L+2,4) + 1), 4 ) + 1
  LZX3 = MOD( (MOD(L+2,4) + 2), 4 ) + 1

  DO  I  = 3, MX1T

    VUT (I,L) = VUT (I,L) + COD *                                      &
                  ( TXXT   (I  )      - TXXT   (I-1)                   &
                  + TZXMWT (I  ,LZX3) - TZXMWT (I  ,LZX2) )

  END DO

! vw (I,L) == vw (I+1/2,L)

  LZZ2 = MOD( (MOD(L+1,4) + 2), 4 ) + 1
  LZZ3 = MOD( (MOD(L+1,4) + 3), 4 ) + 1

  DO  I  = 2, MX1T

    VWT (I,L) = VWT (I,L) + COD *                                      &
                  ( TZZMWT (I  ,LZZ3) - TZZMWT (I  ,LZZ2)              &
                  + TZXMWT (I+1,LZX2) - TZXMWT (I  ,LZX2) )

  END DO

END SUBROUTINE  MZ1_V
