!=======================================================================

SUBROUTINE PRE_NR_COEF0

  USE GRID_MEDIUM , ONLY:                                              &
                          H
  USE CONTROL_DATA, ONLY:                                              &
                          COVP, COVS,                                  &
                          KTLE, KTRI, KTBO,                            &
                          THPPLE, THPPRI, THPPBO,                      &
                          THSSLE, THSSRI, THSSBO
  USE NONREF_BOUND, ONLY:                                              &
                                  CALE01, CALE02,                      &
                          CALE10, CALE11, CALE12,                      &
                          CALE20, CALE21, CALE22,                      &
                                  CARI01, CARI02,                      &
                          CARI10, CARI11, CARI12,                      &
                          CARI20, CARI21, CARI22,                      &
                                  CABT01, CABT02,                      &
                          CABT10, CABT11, CABT12,                      &
                          CABT20, CABT21, CABT22

  IMPLICIT NONE

  INTERFACE

    SUBROUTINE     NONREF ( H, KEY, ALFA, BETA, THPP, THSS,            &
                            AX01,AX02,AX10,AX11,AX12,AX20,AX21,AX22 )
      USE PRECISION, ONLY: WP
      INTEGER     , INTENT (IN)  :: KEY
      REAL    (WP), INTENT (IN)  :: H, ALFA, BETA, THPP, THSS
      REAL    (WP), INTENT (OUT) ::       AX01, AX02,                  &
                                    AX10, AX11, AX12,                  &
                                    AX20, AX21, AX22
    END SUBROUTINE NONREF

  END INTERFACE

!_________________________________________________ HOMOGENEOUS MEDIUM __

!___________________________________________________ LEFT TRANSPARENT __

  CALL NONREF ( H, KTLE, COVP  , COVS  ,                               &
                THPPLE , THSSLE,                                       &
                         CALE01, CALE02,                               &
                 CALE10, CALE11, CALE12,                               &
                 CALE20, CALE21, CALE22  )

!__________________________________________________ RIGHT TRANSPARENT __

  CALL NONREF ( H, KTRI, COVP  , COVS  ,                               &
                THPPRI , THSSRI,                                       &
                         CARI01, CARI02,                               &
                 CARI10, CARI11, CARI12,                               &
                 CARI20, CARI21, CARI22  )

 !________________________________________________ BOTTOM TRANSPARENT __

  CALL NONREF ( H, KTBO, COVP  , COVS  ,                               &
                THPPBO , THSSBO,                                       &
                         CABT01, CABT02,                               &
                 CABT10, CABT11, CABT12,                               &
                 CABT20, CABT21, CABT22  )

END SUBROUTINE PRE_NR_COEF0
