!=======================================================================

SUBROUTINE PRE_NR_COEF1

  USE PRECISION   , ONLY:                                              &
                          WP
  USE CONTROL_DATA, ONLY:                                              &
                          MX, DT,                                      &
                          KTLE  , KTRI  ,                              &
                          THPPLE, THPPRI,                              &
                          THSSLE, THSSRI
  USE GRID_MEDIUM , ONLY:                                              &
                          H, JM, LAM, MU, DENW
  USE AUXIL       , ONLY:                                              &
                          LINH
  USE NONREF_BOUND, ONLY:                                              &
                                 ALE01, ALE02,        ARI01, ARI02,    &
                          ALE10, ALE11, ALE12, ARI10, ARI11, ARI12,    &
                          ALE20, ALE21, ALE22, ARI20, ARI21, ARI22

  IMPLICIT NONE

  INTEGER      :: L, JM1

  REAL    (WP) :: ALFA, BETA

  INTERFACE

    SUBROUTINE     NONREF ( H, KEY, ALFA, BETA, THPP, THSS,            &
                            AX01,AX02,AX10,AX11,AX12,AX20,AX21,AX22 )
      USE PRECISION, ONLY: WP
      INTEGER     , INTENT (IN)  :: KEY
      REAL    (WP), INTENT (IN)  :: H, ALFA, BETA, THPP, THSS
      REAL    (WP), INTENT (OUT) ::       AX01, AX02,                  &
                                    AX10, AX11, AX12,                  &
                                    AX20, AX21, AX22
    END SUBROUTINE NONREF

  END INTERFACE

!_______________________________________________ HETEROGENEOUS MEDIUM __

  DO  L = 0, LINH

!___________________________________________________ LEFT TRANSPARENT __

    JM1  = JM (1,L)
    ALFA = SQRT( ( LAM (JM1) + 2 * MU (JM1) ) * DENW (JM1) * H*H/DT )
    BETA = SQRT(                   MU (JM1)   * DENW (JM1) * H*H/DT )

    CALL NONREF ( H, KTLE, ALFA, BETA, THPPLE, THSSLE,                 &
                             ALE01 (L), ALE02 (L),                     &
                  ALE10 (L), ALE11 (L), ALE12 (L),                     &
                  ALE20 (L), ALE21 (L), ALE22 (L)      )

!__________________________________________________ RIGHT TRANSPARENT __

    JM1  = JM (MX,L)
    ALFA = SQRT( ( LAM (JM1) + 2 * MU (JM1) ) * DENW (JM1) * H*H/DT )
    BETA = SQRT(                   MU (JM1)   * DENW (JM1) * H*H/DT )

    CALL NONREF ( H, KTRI, ALFA, BETA, THPPRI, THSSRI,                 &
                            ARI01 (L), ARI02 (L),                      &
                  ARI10(L), ARI11 (L), ARI12 (L),                      &
                  ARI20(L), ARI21 (L), ARI22 (L)       )

  END DO

END SUBROUTINE PRE_NR_COEF1
