!=======================================================================

SUBROUTINE  READ_MODEL

  USE PRECISION   , ONLY:                                              &
                          WP
  USE GRID_MEDIUM , ONLY:                                              &
                          JMNUM, H, JM,                                &
                          DENU, DENW,   LAM,   MU,  MUXZ,              &
                                       YLAM,  YMU, YMUXZ,              &
                                      CYLAM, CYMU, CYL2M
  USE CONTROL_DATA, ONLY:                                              &
                          MX, MZ, DT, KEY_SH, KEY_1D
  USE AUXIL       , ONLY:                                              &
                          OSA, LINH

  IMPLICIT NONE

  INTEGER :: JM1, ALLOSTAT, J, MUL


  ALLOCATE ( JM (1:MX, 0:LINH+3),                    STAT=ALLOSTAT )

    IF  ( ALLOSTAT > 0 )  THEN
      WRITE (11,*) '  ALLOCATION ERROR R_M_PAR_01, STAT= ', ALLOSTAT
      STOP
    END IF

  READ ( 13 ) JM

  READ ( 14 ) JMNUM

  ALLOCATE ( DENU (JMNUM), DENW (JMNUM),                               &
             LAM  (JMNUM), MU   (JMNUM), MUXZ (JMNUM),                 &
                                                 STAT=ALLOSTAT )

    IF  ( ALLOSTAT > 0 )  THEN
      WRITE (11,*) '  ALLOCATION ERROR R_M_PAR_02, STAT= ', ALLOSTAT
      STOP
    END IF

  READ  ( 14 ) ( DENU(JM1), DENW(JM1),                                 &
                 LAM (JM1), MU  (JM1), MUXZ(JM1), JM1 = 1, JMNUM)

  DENU = DT/H/DENU
  DENW = DT/H/DENW

  LAM  = LAM /H
  MU   = MU  /H
  MUXZ = MUXZ/H

  MUL = 4
  IF ( KEY_1D ) THEN
    MUXZ = 0.
    MUL = 2
  END IF

  ALLOCATE ( YMU   (JMNUM, 4), YLAM  (JMNUM, 4),                       &
             YMUXZ (JMNUM, 4),                   STAT=ALLOSTAT )

    IF  ( ALLOSTAT > 0 )  THEN
      WRITE (11,*) '  ALLOCATION ERROR R_M_PAR_03, STAT= ', ALLOSTAT
      STOP
    END IF

  READ  ( 15 ) ( YMU  (JM1,:), YLAM (JM1,:),                           &
                 YMUXZ(JM1,:),               JM1 = 1, JMNUM)

  DO J = 1, 4
    YLAM  (:,J) = YLAM  (:,J) * OSA (J) * LAM  (:)*MUL
    YMU   (:,J) = YMU   (:,J) * OSA (J) * MU   (:)*MUL
    YMUXZ (:,J) = YMUXZ (:,J) * OSA (J) * MUXZ (:)*MUL
  END DO

  CYLAM = YLAM ( JM (3,LINH), : )
  CYMU  = YMU  ( JM (3,LINH), : )
  CYL2M = CYLAM + 2._WP*CYMU

  CLOSE ( 13 )
  CLOSE ( 14 )
  CLOSE ( 15 )

  IF ( KEY_SH ) THEN
     LAM  = -  MU
    YLAM  = - YMU
    CYLAM = -CYMU
    CYL2M =  CYMU
  END IF

END SUBROUTINE  READ_MODEL
