!=======================================================================

SUBROUTINE  READ_OPEN  ( WORK_NAME )

  USE GRID_MEDIUM , ONLY:                                              &
                          TEXT, JM, H, CODEN
  USE CONTROL_DATA, ONLY:                                              &
                          KEY_CONT, KEY_TLV, KEY_TLD,                  &
                          KEY_SH ,  KEY_SNV, KEY_SND, KEY_1D,          &
                          MX, MZ, LHOM, LIN3,                          &
                          MT1, MT2, IPAS1, IPAS2, MR, MTS,             &
                          DT, COVP, COVS,                              &
                          OMG, WB, FRJMAX, FRANGE,                     &
                            KLCH,   KRCH,                              &
                            KTLE,   KTRI,   KTBO,                      &
                          THPPLE, THPPRI, THPPBO,                      &
                          THSSLE, THSSRI, THSSBO,                      &
                          IREC, LREC

  IMPLICIT NONE

  CHARACTER (LEN=*), INTENT (IN) :: WORK_NAME

  CHARACTER*20 LOG_FILE_NAME, IN_FILE_NAME,                            &
                JM_FILE_NAME, MO_FILE_NAME,                            &
                 Q_FILE_NAME, SR_FILE_NAME

  LOGICAL :: EX

  INTEGER :: IOS, I, ALLOSTAT

  NAMELIST /NAMES/        JM_FILE_NAME, MO_FILE_NAME, Q_FILE_NAME,     &
                          SR_FILE_NAME

  NAMELIST /KEYS/         KEY_TLV, KEY_TLD, KEY_SNV, KEY_SND, KEY_CONT,&
                          KEY_SH, KEY_1D

  NAMELIST /CONT_DATA/    MT1, MT2, IPAS1, MX, MZ, LHOM, LIN3, DT

  NAMELIST /ATTEN/        FRJMAX, FRANGE

  NAMELIST /NONREF/       OMG,WB,   KLCH,   KRCH,                      &
                            KTLE,   KTRI,   KTBO,                      &
                          THPPLE, THPPRI, THPPBO,                      &
                          THSSLE, THSSRI, THSSBO

  NAMELIST /TXT/          TEXT

  NAMELIST /HMOD/         H, CODEN, COVP, COVS

  NAMELIST /SNAP/         MTS, IPAS2

  NAMELIST /REC/          MR

!______________________________________________ LOG FILE __________ 11 _

  LOG_FILE_NAME = WORK_NAME//'.LOG'

  OPEN  (11, FILE = LOG_FILE_NAME, STATUS='UNKNOWN' )
  WRITE (11,*) 'LOG_FILE: JOB_NAME =', WORK_NAME

!______________________________________________ CONTROL DATA FILE _ 12 _

  IN_FILE_NAME = WORK_NAME//'.IN'

  INQUIRE ( FILE = IN_FILE_NAME, EXIST=EX, IOSTAT=IOS )
    IF  ( IOS > 0 )  THEN
      WRITE (11,*) 'ERROR HAS OCCURED DURING THE EXECUTION             &
                   &OF THE INQUIRE STATEMENT.',                        &
                   'IOSTAT (IN_FILE_NAME)=',IOS
      STOP
    END IF
    IF  ( .NOT.EX )  THEN
      WRITE (11,*) IN_FILE_NAME,' NOT FOUND'
      STOP
    END IF
  OPEN  (12, FILE = IN_FILE_NAME, STATUS='OLD' )

!______________________________________________ READ CONTROL DATA ______

  READ  (12, NML=NAMES)
  WRITE (11, NML=NAMES)

  KEY_SH = .FALSE.
  KEY_1D = .FALSE.
  READ  (12, NML=KEYS)
  WRITE (11, NML=KEYS)

  IF  ( .NOT. ( KEY_TLV .OR. KEY_TLD .OR. KEY_SNV .OR. KEY_SND ) ) THEN
    WRITE (11,*) ' NONE OF TL_, OR SN_ OUTPUT FILES IS REQUIRED'
    STOP
  END IF

  READ  (12, NML=CONT_DATA)
  WRITE (11, NML=CONT_DATA)

  READ  (12, NML=ATTEN)
  WRITE (11, NML=ATTEN)

  WB     = 0.4
  THPPLE = 0.19757
  THPPRI = 0.19757
  THPPBO = 0.19757
  THSSLE = 0.70511
  THSSRI = 0.70511
  THSSBO = 0.70511
  READ  (12, NML=NONREF)
  WRITE (11, NML=NONREF)

  READ  (12, NML=TXT)
  WRITE (11, NML=TXT)

  READ  (12, NML=HMOD)
  WRITE (11, NML=HMOD)

  IF  ( KEY_SNV .OR. KEY_SND )  THEN
    READ  (12, NML=SNAP)
    WRITE (11, NML=SNAP)
  END IF

  IF  ( KEY_TLV .OR. KEY_TLD )  THEN
    READ  (12, NML=REC)
    WRITE (11, NML=REC)

    ALLOCATE ( IREC  (1:MR), LREC (1:MR),   STAT=ALLOSTAT )
      IF  ( ALLOSTAT > 0 )  THEN
        WRITE (11,*) '  ALLOCATION ERROR R_O_01, STAT=', ALLOSTAT
        STOP
      END IF

    READ  (12,*)  ( IREC(I), LREC(I), I=1,MR )
  END IF

  CLOSE (12)

!______________________________________________ MODEL FILES _ 13,14,15 _

  INQUIRE ( FILE = MO_FILE_NAME, EXIST=EX, IOSTAT=IOS )
    IF  ( IOS > 0 )  THEN
      WRITE (11,*) 'ERROR HAS OCCURED DURING THE EXECUTION             &
                   &OF THE INQUIRE STATEMENT.',                        &
                   'IOSTAT (MO_FILE_NAME)=',IOS
      STOP
    END IF
    IF  ( .NOT.EX )  THEN
      WRITE (11,*) MO_FILE_NAME,' NOT FOUND'
      STOP
    END IF

  INQUIRE ( FILE = JM_FILE_NAME, EXIST=EX, IOSTAT=IOS )
    IF  ( IOS > 0 )  THEN
      WRITE (11,*) 'ERROR HAS OCCURED DURING THE EXECUTION             &
                   &OF THE INQUIRE STATEMENT.',                        &
                   'IOSTAT (JM_FILE_NAME)=',IOS
      STOP
    END IF
    IF  ( .NOT.EX )  THEN
      WRITE (11,*) JM_FILE_NAME,' NOT FOUND'
      STOP
    END IF

  INQUIRE ( FILE =  Q_FILE_NAME, EXIST=EX, IOSTAT=IOS )
    IF  ( IOS > 0 )  THEN
      WRITE (11,*) 'ERROR HAS OCCURED DURING THE EXECUTION             &
                   &OF THE INQUIRE STATEMENT.',                        &
                   'IOSTAT (Q_FILE_NAME)=',IOS
      STOP
    END IF
    IF  ( .NOT.EX )  THEN
      WRITE (11,*)  Q_FILE_NAME,' NOT FOUND'
      STOP
    END IF

  OPEN ( 13, FILE = JM_FILE_NAME, FORM = 'UNFORMATTED',  STATUS='OLD' )

  OPEN ( 14, FILE = MO_FILE_NAME, FORM = 'UNFORMATTED',  STATUS='OLD' )

  OPEN ( 15, FILE =  Q_FILE_NAME, FORM = 'UNFORMATTED',  STATUS='OLD' )

!____________________________________________________ SOURCE FILE _ 16 _

  INQUIRE ( FILE = SR_FILE_NAME, EXIST=EX, IOSTAT=IOS )
    IF  ( IOS > 0 )  THEN
      WRITE (11,*) 'ERROR HAS OCCURED DURING THE EXECUTION             &
                   &OF THE INQUIRE STATEMENT.',                        &
                   'IOSTAT (MO_FILE_NAME)=',IOS
      STOP
    END IF
    IF  ( .NOT.EX )  THEN
      WRITE (11,*) SR_FILE_NAME,' NOT FOUND'
      STOP
    END IF

  OPEN ( 16, FILE = SR_FILE_NAME, FORM = 'FORMATTED', STATUS='OLD' )

!_______________________________ OUPUT FILES _ 20,21,22,23,25,26,27,28 _

  IF ( MT1 > 1 ) THEN
    IF ( KEY_TLV ) THEN
      IF ( KEY_SH ) THEN
        OPEN ( 21, FILE='REC_VV.DAT' , POSITION = 'APPEND', STATUS='OLD')
        OPEN ( 23, FILE='REC_VV0.DAT', POSITION = 'APPEND', STATUS='OLD')
      ELSE IF ( .NOT.(KEY_SH) .AND. KEY_1D ) THEN
        OPEN ( 21, FILE='REC_VW.DAT' , POSITION = 'APPEND', STATUS='OLD')
        OPEN ( 23, FILE='REC_VW0.DAT', POSITION = 'APPEND', STATUS='OLD')
      ELSE
        OPEN ( 20, FILE='REC_VU.DAT' , POSITION = 'APPEND', STATUS='OLD')
        OPEN ( 21, FILE='REC_VW.DAT' , POSITION = 'APPEND', STATUS='OLD')
        OPEN ( 22, FILE='REC_VU0.DAT', POSITION = 'APPEND', STATUS='OLD')
        OPEN ( 23, FILE='REC_VW0.DAT', POSITION = 'APPEND', STATUS='OLD')
      END IF
    END IF

    IF ( KEY_TLD ) THEN
      IF ( KEY_SH ) THEN
        OPEN ( 26, FILE='REC_V.DAT'  , POSITION = 'APPEND', STATUS='OLD')
        OPEN ( 28, FILE='REC_V0.DAT' , POSITION = 'APPEND', STATUS='OLD')
      ELSE IF ( .NOT.(KEY_SH) .AND. KEY_1D ) THEN
        OPEN ( 26, FILE='REC_W.DAT'  , POSITION = 'APPEND', STATUS='OLD')
        OPEN ( 28, FILE='REC_W0.DAT' , POSITION = 'APPEND', STATUS='OLD')
      ELSE
        OPEN ( 25, FILE='REC_U.DAT'  , POSITION = 'APPEND', STATUS='OLD')
        OPEN ( 26, FILE='REC_W.DAT'  , POSITION = 'APPEND', STATUS='OLD')
        OPEN ( 27, FILE='REC_U0.DAT' , POSITION = 'APPEND', STATUS='OLD')
        OPEN ( 28, FILE='REC_W0.DAT' , POSITION = 'APPEND', STATUS='OLD')
      END IF
    END IF
  ELSE
    IF ( KEY_TLV ) THEN
      IF ( KEY_SH ) THEN
        OPEN ( 21, FILE='REC_VV.DAT'                    , STATUS='NEW' )
        OPEN ( 23, FILE='REC_VV0.DAT'                   , STATUS='NEW' )
      ELSE IF ( .NOT.(KEY_SH) .AND. KEY_1D ) THEN
        OPEN ( 21, FILE='REC_VW.DAT'                    , STATUS='NEW')
        OPEN ( 23, FILE='REC_VW0.DAT'                   , STATUS='NEW')
      ELSE
        OPEN ( 20, FILE='REC_VU.DAT'                    , STATUS='NEW' )
        OPEN ( 21, FILE='REC_VW.DAT'                    , STATUS='NEW' )
        OPEN ( 22, FILE='REC_VU0.DAT'                   , STATUS='NEW' )
        OPEN ( 23, FILE='REC_VW0.DAT'                   , STATUS='NEW' )
      END IF
    END IF

    IF ( KEY_TLD ) THEN
      IF ( KEY_SH ) THEN
        OPEN ( 26, FILE='REC_V.DAT'                     , STATUS='NEW' )
        OPEN ( 28, FILE='REC_V0.DAT'                    , STATUS='NEW' )
      ELSE IF ( .NOT.(KEY_SH) .AND. KEY_1D ) THEN
        OPEN ( 26, FILE='REC_W.DAT'                     , STATUS='NEW' )
        OPEN ( 28, FILE='REC_W0.DAT'                    , STATUS='NEW' )
      ELSE
        OPEN ( 25, FILE='REC_U.DAT'                     , STATUS='NEW' )
        OPEN ( 26, FILE='REC_W.DAT'                     , STATUS='NEW' )
        OPEN ( 27, FILE='REC_U0.DAT'                    , STATUS='NEW' )
        OPEN ( 28, FILE='REC_W0.DAT'                    , STATUS='NEW' )
      END IF
    END IF
  END IF

END SUBROUTINE  READ_OPEN
