!=======================================================================

SUBROUTINE  REC (T, UT, WT, OP_F1, OP_F2)

  USE PRECISION   , ONLY:                                              &
                          WP
  USE CONTROL_DATA, ONLY:                                              &
                          MR, IREC, LREC, KEY_SH, KEY_1D
  USE WAVEFIELD   , ONLY:                                              &
                          SEIS
  IMPLICIT NONE

  INTEGER     ,                  INTENT(IN) :: OP_F1, OP_F2
  REAL    (WP),                  INTENT(IN) :: T
  REAL    (WP), DIMENSION(:,0:), INTENT(IN) :: UT, WT

  INTEGER :: I

!_______________________________________________________ U COMPONENT ___

  IF ( .NOT. (KEY_SH) .AND. .NOT.(KEY_1D) ) THEN
    DO  I = 1, MR

      SEIS (I) = UT ( IREC(I), LREC(I) )

      IF ( ABS(SEIS (I)) .LE. .1E-30 ) SEIS (I) = 0.

    END DO

    WRITE (OP_F1,'(255(X,E12.6))') T, ( SEIS (I), I = 1, MR )
  END IF

!_______________________________________________________ W COMPONENT ___

  DO  I = 1, MR

    SEIS (I) = WT ( IREC(I), LREC(I) )

    IF ( ABS(SEIS (I)) .LE. .1E-30 ) SEIS (I) = 0.

  END DO

  WRITE (OP_F2,'(255(X,E12.6))') T, ( SEIS (I), I = 1, MR )


END SUBROUTINE  REC
