!=======================================================================

SUBROUTINE START_DATA  ( WORK_NAME )

  USE PRECISION   , ONLY:                                              &
                          WP

  USE CONTROL_DATA, ONLY:                                              &
                          MX, MZ, MT1, MR, KEY_TLV, KEY_TLD, KEY_CONT
  USE AUXIL       , ONLY:                                              &
                          UST02 , UST03  , UST04  ,                    &
                          WST01 , WST02  , WST03  ,                    &
                          UST0MX, UST0MX1, UST0MX2,                    &
                          WST0MX, WST0MX1, WST0MX2,                    &
                          UST0MZ, UST0MZ1, UST0MZ2,                    &
                          WST0MZ, WST0MZ1, WST0MZ2
  USE WAVEFIELD   , ONLY:                                              &
                          SEIS,                                        &
                          U, VU, W, VW, TU1, TU2, TU3,                 &
                                        TW1, TW2, TW3,                 &
                          XXX, XZX, XTZX, XRZX,                        &
                               XZZ, XTZZ, XRZZ

  IMPLICIT NONE

  CHARACTER (LEN=*), INTENT (IN) :: WORK_NAME

  INTEGER            :: IOS, I
  LOGICAL            :: EX
  CHARACTER (LEN=20) :: CO_FILE_NAME


  CO_FILE_NAME = WORK_NAME//'.CO'
  INQUIRE ( FILE = CO_FILE_NAME, EXIST=EX, IOSTAT=IOS )

  IF  ( IOS > 0 )  THEN
    WRITE (11,*) 'ERROR HAS OCCURED DURING THE EXECUTION               &
                 &OF THE INQUIRE STATEMENT.',                          &
                 'IOSTAT CONTINUE.DAT=',IOS
    STOP
  END IF

!____________________________________________________ 0 - START_DATA ___

  IF  ( MT1 .EQ. 1 ) THEN

    IF  ( EX ) THEN
      WRITE (11,*) ' MT1 IS EQUAL TO 1 AND CONT. FILE ALREADY EXISTS'
      STOP
    END IF

     U  = 0._WP ;  W  = 0._WP
    VU  = 0._WP ; VW  = 0._WP

    XXX = 0._WP
    XZX = 0._WP ; XTZX = 0._WP ; XRZX = 0._WP
    XZZ = 0._WP ; XTZZ = 0._WP ; XRZZ = 0._WP

    SEIS    = 0._WP

    UST02   = 0._WP ; UST03   = 0._WP ; UST04   = 0._WP
    WST01   = 0._WP ; WST02   = 0._WP ; WST03   = 0._WP

    UST0MX  = 0._WP ; UST0MX1 = 0._WP ; UST0MX2 = 0._WP
    WST0MX  = 0._WP ; WST0MX1 = 0._WP ; WST0MX2 = 0._WP

    UST0MZ  = 0._WP ; UST0MZ1 = 0._WP ; UST0MZ2 = 0._WP
    WST0MZ  = 0._WP ; WST0MZ1 = 0._WP ; WST0MZ2 = 0._WP

!________________________________________________ START OUTPUT FILES ___

    IF  ( KEY_TLV ) THEN

      WRITE (20,'(255(X,E12.6))') 0., ( SEIS (I), I = 1, MR )
      WRITE (21,'(255(X,E12.6))') 0., ( SEIS (I), I = 1, MR )
      WRITE (22,'(255(X,E12.6))') 0., ( SEIS (I), I = 1, MR )
      WRITE (23,'(255(X,E12.6))') 0., ( SEIS (I), I = 1, MR )

    END IF

    IF  ( KEY_TLD ) THEN

      WRITE (25,'(255(X,E12.6))') 0., ( SEIS (I), I = 1, MR )
      WRITE (26,'(255(X,E12.6))') 0., ( SEIS (I), I = 1, MR )
      WRITE (27,'(255(X,E12.6))') 0., ( SEIS (I), I = 1, MR )
      WRITE (28,'(255(X,E12.6))') 0., ( SEIS (I), I = 1, MR )

    END IF

    IF ( KEY_CONT ) THEN
      OPEN (50, FILE = WORK_NAME//'.CO', FORM  = 'UNFORMATTED',        &
                                         STATUS='NEW' )
    END IF

!_____________________________________________________ CONTINUE DATA ___

  ELSE IF  ( MT1 >= 2 ) THEN

    IF  ( .NOT. EX ) THEN
      WRITE (11,*) ' MT1 IS GREATER THAN 1 AND CONT. FILE NOT FOUND'
      STOP
    END IF

    OPEN (50, FILE = WORK_NAME//'.CO',  FORM  = 'UNFORMATTED',         &
                                        STATUS='OLD' )

    READ (50) U, W, VU, VW

    READ (50) XXX,                                                     &
              XZX, XTZX, XRZX,                                         &
              XZZ, XTZZ, XRZZ

    READ (50) UST02 , UST03  , UST04  ,                                &
              WST01 , WST02  , WST03  ,                                &
              UST0MX, UST0MX1, UST0MX2,                                &
              WST0MX, WST0MX1, WST0MX2,                                &
              UST0MZ, UST0MZ1, UST0MZ2,                                &
              WST0MZ, WST0MZ1, WST0MZ2

    IF ( KEY_CONT ) THEN
      REWIND (50)
    ELSE
      CLOSE  (50)
    END IF

  END IF

END SUBROUTINE START_DATA
