!=======================================================================

SUBROUTINE  VEL_OFF_SOURCE (IT)

  USE PRECISION   , ONLY:                                              &
                          WP
  USE CONTROL_DATA, ONLY:                                              &
                          LHOM,                                        &
                          DT, IPAS1, MTS, IPAS2,                       &
                          KEY_TLV, KEY_SNV, KEY_SH, KEY_1D
  USE AUXIL       , ONLY:                                              &
                          LINH, MZ3
  USE WAVEFIELD   , ONLY:                                              &
                          VU, VW
  USE T_LOOP      , ONLY:                                              &
                          TR
  USE T_INTERFACES, ONLY:                                              &
                          HLINE_0, HLINE_1, HLINE_2  ,                 &
                          HLINE_I, HLINE_H, HLINE_MZ2, HLINE_MZ1,      &
                          REC, REC0, SNAP
  IMPLICIT NONE

  INTEGER, INTENT(IN) :: IT

  INTEGER             :: L


  TR = (IT-1) * DT

!__________________________________________________________ VELOCITY ___

  CALL  HLINE_0

  CALL  HLINE_1

  CALL  HLINE_2

  DO  L = 3, LINH
    CALL HLINE_I (L)
  END DO

  DO  L = LHOM, MZ3
    CALL HLINE_H (L)
  END DO

  CALL HLINE_MZ2

  CALL HLINE_MZ1

  IF ( KEY_SH .OR. KEY_1D ) THEN
    VU = 0.
  END IF
!___________________________________________ RECORD FILES - VELOCITY ___

  IF  ( KEY_TLV ) THEN
    IF  ( MOD(IT,IPAS1) .EQ. 0 ) THEN
      CALL  REC  ( T = TR + 0.5_WP*DT, UT    = VU, WT    = VW,         &
                                       OP_F1 = 20, OP_F2 = 21 )
      CALL  REC0 ( T = TR + 0.5_WP*DT, UT    = VU, WT    = VW,         &
                                       OP_F3 = 22, OP_F4 = 23 )
    END IF
  END IF

  IF  ( KEY_SNV ) THEN
    IF  ( IT .LE. MTS ) THEN
      IF  ( MOD(IT,IPAS2) .EQ. 0 ) THEN
        CALL SNAP ( NUMSNAP = IT, UT = VU , WT = VW,                   &
                    SN_BASE_1 = 'SNAP_VU.', SN_BASE_2 = 'SNAP_VW.' )
      END IF
    END IF
  END IF

END SUBROUTINE  VEL_OFF_SOURCE
