!=======================================================================
! subroutine allocates some variables
!=======================================================================

SUBROUTINE ALLOC

  USE MOD_PRECISION , ONLY : WP
  USE MOD_ATTEN     , ONLY : N_FREQ, N2_FREQ, YMUZX, YMU, YL2M, YMI, YKI
  USE MOD_MODEL     , ONLY : NP, NI, MX, LHOM, PTS, PTS2,              &
                             IPAR, INT_SED, KEY_Q
  USE MOD_PARAMETERS, ONLY : RHOU, RHOW, MUZX, MU, L2M,                &
                             RHOI, MI, KI, JM

!-----------------------------------------------------------------------

  IMPLICIT NONE

  ALLOCATE ( INT_SED(0:NI,1:NP) )
  ALLOCATE ( JM(1:MX,0:LHOM+2) )

  ALLOCATE ( RHOU(1:MX,0:LHOM+2), RHOW(1:MX,0:LHOM+2) )
  ALLOCATE ( MUZX(1:MX,0:LHOM+2), MU(1:MX,0:LHOM+2), L2M(1:MX,0:LHOM+2) )
  RHOU = 0._WP
  RHOW = 0._WP
  MUZX = 0._WP
  MU   = 0._WP
  L2M  = 0._WP

  ALLOCATE ( RHOI(1:MX*(PTS2-1)+PTS+1,1:PTS2+PTS) )
  ALLOCATE ( MI  (1:MX*(PTS2-1)+PTS+1,1:PTS2+PTS) )
  ALLOCATE ( KI  (1:MX*(PTS2-1)+PTS+1,1:PTS2+PTS) )
  RHOI = 0._WP
    MI = 0._WP
    KI = 0._WP

  IF (KEY_Q) THEN
    ALLOCATE ( YMUZX(1:MX,0:LHOM+2,1:N_FREQ),                          &
               YMU  (1:MX,0:LHOM+2,1:N_FREQ),                          &
               YL2M (1:MX,0:LHOM+2,1:N_FREQ) )
    YMUZX = 0._WP
    YMU   = 0._WP
    YL2M  = 0._WP
    ALLOCATE ( YMI(1:MX*(PTS2-1)+PTS+1,1:PTS2+PTS,1:N2_FREQ) )
    ALLOCATE ( YKI(1:MX*(PTS2-1)+PTS+1,1:PTS2+PTS,1:N2_FREQ) )
    YMI = 0._WP
    YKI = 0._WP
  END IF

END SUBROUTINE ALLOC
