!=======================================================================
! function finds in which layer the point with coordinates (XX,ZZ)
! is laying
!=======================================================================

FUNCTION GET_LAYER(XX,ZZ)

  USE MOD_PRECISION, ONLY : WP
  USE MOD_MODEL    , ONLY : NP, NI, INT_SED

!-----------------------------------------------------------------------

  IMPLICIT NONE

  INTEGER  :: GET_LAYER
  REAL(WP) :: XX, ZZ

  INTEGER  :: I, J, P, TMP
  REAL(WP) :: X1, X2, Z1, Z2, ZA

!-----------------------------------------------------------------------
!  OPEN (20, FILE=FILE_SED, STATUS='OLD')
!    DO I = 1, NP
!      READ (20,*) INT_SED(:,I)
!    END DO
!  CLOSE(20)

  P = 1

  ! Finding points of the interpolated interface between which the point
  ! with coordinate XX is laying
  DO I = 1, NP-1
    X1 = INT_SED(0,I  )
    X2 = INT_SED(0,I+1)
    IF ( ( X1 <= XX ) .AND. ( XX <= X2 ) ) THEN
      P = I
      EXIT
    END IF
  END DO

  TMP = NI

  ! Finding LAYER in which the point with coordinate ZZ is laying
  DO  J = NI, 1, -1

    Z1 = INT_SED(J,P  )
    Z2 = INT_SED(J,P+1)
    ZA = Z1 + (XX-X1) * (Z2-Z1) / ( X2-X1 )

    IF ( (ZA<=ZZ) .OR. (TMP==1) ) EXIT

    TMP = TMP - 1

  END DO

  GET_LAYER = TMP

END FUNCTION GET_LAYER
