!=======================================================================
! subroutine integrates the parameter PARAM over volume PTS*PTS
!=======================================================================

!FUNCTION INT2D(IMIN,IMAX,LMIN,LMAX,PARAM)
FUNCTION INT2D(PARAM)

  USE MOD_PRECISION, ONLY : WP
  USE MOD_MODEL    , ONLY : PTS2

  IMPLICIT NONE

!-----------------------------------------------------------------------

  REAL(WP) :: INT2D
  REAL(WP), DIMENSION(1:PTS2,1:PTS2) :: PARAM

  INTEGER  :: IP, LP
  REAL(WP) :: TMP, PTS2_2

!-----------------------------------------------------------------------

  PTS2_2 = PTS2 * PTS2
  TMP    = 0._WP

  DO IP = 1, PTS2
    DO LP = 1, PTS2
      TMP = TMP + PARAM(IP,LP)
    END DO
  END DO

  INT2D = TMP / PTS2_2

END FUNCTION INT2D
