!=======================================================================
! subroutine integrates the complex parameter PARAM over volume PTS*PTS
!=======================================================================

FUNCTION INT2D_Y(PARAM)

  USE MOD_PRECISION, ONLY : WP
  USE MOD_ATTEN    , ONLY : N_FREQ, N2_FREQ
  USE MOD_MODEL    , ONLY : PTS2

  IMPLICIT NONE

!-----------------------------------------------------------------------

  REAL(WP)   , DIMENSION(1:N_FREQ)                :: INT2D_Y
  COMPLEX(WP), DIMENSION(1:PTS2,1:PTS2,1:N2_FREQ) :: PARAM

  INTEGER     :: IP, LP, K
  REAL(WP)    :: PTS2_2

  REAL(WP)   , DIMENSION(1: N_FREQ) :: Y
  REAL(WP)   , DIMENSION(1:N2_FREQ) :: Q
  COMPLEX(WP), DIMENSION(1:N2_FREQ) :: TMP

!-----------------------------------------------------------------------

  INTERFACE
    SUBROUTINE     QYLSM(Q,Y)
      USE MOD_PRECISION , ONLY : WP
      USE MOD_ATTEN     , ONLY : N_FREQ, N2_FREQ, FJK, FJJ
      IMPLICIT NONE
      REAL(WP), DIMENSION (N2_FREQ), INTENT( IN) :: Q
      REAL(WP), DIMENSION ( N_FREQ), INTENT(OUT) :: Y
    END SUBROUTINE QYLSM
  END INTERFACE

!-----------------------------------------------------------------------

  PTS2_2 = PTS2 * PTS2
  TMP    = 0._WP

  DO IP = 1, PTS2
    DO LP = 1, PTS2
      TMP(:) = TMP(:) + PARAM(IP,LP,:)
    END DO
  END DO

  TMP = PTS2_2 / TMP

  Q(:) = REAL(TMP(:)) / AIMAG(TMP(:))
  CALL QYLSM(Q,Y)

  INT2D_Y(:) = Y(:)

END FUNCTION INT2D_Y
