!=======================================================================

MODULE MOD_INTERFACES

!-----------------------------------------------------------------------

  IMPLICIT NONE

  INTERFACE


    SUBROUTINE     ALLOC
    END SUBROUTINE ALLOC

    SUBROUTINE     PARAMETERS_INDICES
    END SUBROUTINE PARAMETERS_INDICES

    SUBROUTINE     PREPARE_ATTEN
    END SUBROUTINE PREPARE_ATTEN

    SUBROUTINE     PREPARE_INTEG(LL)
      USE MOD_PRECISION , ONLY : WP
      USE MOD_CONST     , ONLY : C43
      USE MOD_FUNC      , ONLY : FUNC_RHO, FUNC_VP, FUNC_VS
      USE MOD_MODEL     , ONLY : MX, PTS, PTS2, H, H2, HPTS, XBMIN
      USE MOD_PARAMETERS, ONLY : RHOI, MI, KI
      IMPLICIT NONE
      INTEGER, INTENT(IN) :: LL
    END SUBROUTINE PREPARE_INTEG

    SUBROUTINE     PREPARE_INTEG_Y(LL)
      USE MOD_PRECISION , ONLY : WP
      USE MOD_ATTEN     , ONLY : N_FREQ, N2_FREQ, PLO, THE1, THE2, CF, &
                                 YMI, YKI
      USE MOD_CONST     , ONLY : C43
      USE MOD_FUNC      , ONLY : FUNC_QP, FUNC_QS
      USE MOD_MODEL     , ONLY : MX, PTS, PTS2, H, H2, HPTS, XBMIN
      USE MOD_PARAMETERS, ONLY : MI, KI
      IMPLICIT NONE
      INTEGER, INTENT(IN) :: LL
    END SUBROUTINE PREPARE_INTEG_Y

    SUBROUTINE     PREPARE_MODEL
    END SUBROUTINE PREPARE_MODEL

    SUBROUTINE     PRINT_INFO
    END SUBROUTINE PRINT_INFO

    SUBROUTINE     READ_MODEL
    END SUBROUTINE READ_MODEL

    SUBROUTINE     SETPARAMS
    END SUBROUTINE SETPARAMS

    SUBROUTINE     WRITE_PARAMETERS
    END SUBROUTINE WRITE_PARAMETERS

  !---------------------------------------------------------------------

    FUNCTION     INT2D(PARAM)
      USE MOD_PRECISION, ONLY : WP
      USE MOD_MODEL    , ONLY : PTS2
      IMPLICIT NONE
      REAL(WP) :: INT2D
      REAL(WP), DIMENSION(1:PTS2,1:PTS2) :: PARAM
    END FUNCTION INT2D

    FUNCTION     INT2D_Y(PARAM)
      USE MOD_PRECISION, ONLY : WP
      USE MOD_ATTEN    , ONLY : N_FREQ, N2_FREQ
      USE MOD_MODEL    , ONLY : PTS2
      IMPLICIT NONE
      REAL(WP)   , DIMENSION(1:N_FREQ)                :: INT2D_Y
      COMPLEX(WP), DIMENSION(1:PTS2,1:PTS2,1:N2_FREQ) :: PARAM
    END FUNCTION INT2D_Y


  END INTERFACE

END MODULE MOD_INTERFACES
