!=======================================================================

SUBROUTINE QYLSM(Q,Y)

  USE MOD_PRECISION, ONLY : WP
  USE MOD_ATTEN    , ONLY : N_FREQ, N2_FREQ, FJK, FJJ

  IMPLICIT NONE

!----------------------------------------------------------------------

  REAL(WP), DIMENSION (N2_FREQ), INTENT( IN) :: Q
  REAL(WP), DIMENSION ( N_FREQ), INTENT(OUT) :: Y

  INTEGER  :: I, J, K
  REAL(WP) :: FJ, FI, SUMN

  REAL(WP), DIMENSION(N_FREQ)        :: B, P
  REAL(WP), DIMENSION(N_FREQ,N_FREQ) :: A

!----------------------------------------------------------------------

  DO J = 1, N_FREQ
    B(J) = 0.
    A(J,:) = 0.
    DO K = 1, N2_FREQ
      FJ = FJK(J,K) + FJJ(J,K)/Q(K)
      B(J) = B(J)+ FJ/Q(K)
      DO I = 1, N_FREQ
        FI = FJK(I,K) + FJJ(I,K)/Q(K)
        A(J,I) = A(J,I) + FI*FJ
      END DO
    END DO
  END DO

  DO I = 1, N_FREQ
    SUMN = A(I,I)-DOT_PRODUCT(A(I,1:I-1),A(I,1:I-1))
    IF (SUMN <= 0.0) THEN
      PRINT *, 'CHOLECKY DECOMPOSITION FAILED'
      STOP
    END IF
    P(I)=SQRT(SUMN)
    A(I+1:N_FREQ,I)= ( A(I,I+1:N_FREQ)                                 &
                     - MATMUL(A(I+1:N_FREQ,1:I-1),A(I,1:I-1)) ) / P(I)
  END DO

  DO I = 1, N_FREQ
    Y(I)=(B(I)-DOT_PRODUCT(A(I,1:I-1),Y(1:I-1)))/P(I)
  END DO
  DO I = N_FREQ, 1, -1
    Y(I)=(Y(I)-DOT_PRODUCT(A(I+1:N_FREQ,I),Y(I+1:N_FREQ)))/P(I)
  END DO

END SUBROUTINE QYLSM
