!=======================================================================
! subroutine reads in the interfce(s) of the model and interpolates it
! (them) into th FD grid
!=======================================================================

SUBROUTINE READ_MODEL

  USE MOD_PRECISION, ONLY : WP
  USE MOD_FILES    , ONLY : FILE_SED
  USE MOD_MODEL    , ONLY : NI, NP, INT_SED, H, MX,                    &
                            XBMIN, XBMAX, XIMIN, XIMAX

!-----------------------------------------------------------------------

  IMPLICIT NONE

  INTEGER  :: I
  REAL(WP) :: XMIN, XMAX

!-----------------------------------------------------------------------

                     ! --------------------------- read model interfaces
  OPEN (20, FILE=FILE_SED, STATUS='OLD')
    DO I = 1, NP
      READ (20,*) INT_SED(1:NI,I)
    END DO
  CLOSE(20)

  INT_SED(0,:) = INT_SED(1,:)
  INT_SED(1,:) = 0.

                     !--------- test if area that have to be aproximated
                     !--------- lays inside input mesh
  XMIN = INT_SED(0, 1)
  XMAX = INT_SED(0,NP)

  IF ( ( XIMIN < XMIN ) .OR. ( XMAX < XIMAX ) ) THEN

    WRITE(*,*) 'AREA TO BE APROXIMATED DOES NOT LAY &
                  &INSIDE KNOWN INTERFACE BOUNDARIES.'
    WRITE(*,*                      ) 'KNOWN INTERFACE:'
    WRITE(*,'(A4,F23.10,A4,F23.10)') 'FROM', XMIN, ' TO ', XMAX
    WRITE(*,*                      ) 'AREA TO BE APROXIMATED:'
    WRITE(*,'(A4,F23.10,A4,F23.10)') 'FROM', XIMIN, ' TO ', XIMAX
    WRITE(*,*)

    WRITE(99,*) 'AREA TO BE APROXIMATED DOES NOT LAY &
                   &INSIDE KNOWN INTERFACE BOUNDARIES.'
    WRITE(99,*                      ) 'KNOWN INTERFACE:'
    WRITE(99,'(A4,F23.10,A4,F23.10)') 'FROM', XMIN, ' TO ', XMAX
    WRITE(99,*                      ) 'AREA TO BE APROXIMATED:'
    WRITE(99,'(A4,F23.10,A4,F23.10)') 'FROM', XIMIN, ' TO ', XIMAX

    STOP

  END IF

!  CLOSE(99)

END SUBROUTINE READ_MODEL
