!=======================================================================
! Subroutinw write metrial parameters into output files
!=======================================================================

SUBROUTINE WRITE_PARAMETERS

  USE MOD_PRECISION , ONLY : WP
  USE MOD_ATTEN     , ONLY : N_FREQ, INDEX_Y
  USE MOD_FILES     , ONLY : JM_FILE_NAME, MO_FILE_NAME, Q_FILE_NAME
  USE MOD_MODEL     , ONLY : KEY_Q
  USE MOD_PARAMETERS, ONLY : N_CELLS, JM, INDEX

!-----------------------------------------------------------------------

  IMPLICIT NONE

  INTEGER  :: I
  REAL(WP) :: TMP

  REAL(WP), DIMENSION(1:N_CELLS)          :: LAM
  REAL(WP), DIMENSION(1:N_CELLS,1:N_FREQ) :: YLAM

!-----------------------------------------------------------------------

  WRITE(*,*) ' Writing parameters ...'

  OPEN (30, FILE=JM_FILE_NAME, FORM='UNFORMATTED', STATUS='UNKNOWN')
  WRITE(30) JM(:,:)
  CLOSE(30)


  DO I = 1, N_CELLS
    LAM(I) = INDEX(I,5) - 2._WP*INDEX(I,4)
  END DO
  OPEN (40, FILE=MO_FILE_NAME, FORM='UNFORMATTED', STATUS='UNKNOWN')
  WRITE(40) N_CELLS
  ! RHOU, RHOW, LAMBDA, MU, MUZX
  WRITE(40) ( INDEX(I,1), INDEX(I,2),                                  &
              LAM(I), INDEX(I,4), INDEX(I,3), I=1,N_CELLS )
  CLOSE(40)


  OPEN (50, FILE= Q_FILE_NAME, FORM='UNFORMATTED', STATUS='UNKNOWN')
  IF (KEY_Q) THEN
    DO I = 1, N_CELLS
      YLAM(I,:) = ( INDEX(I,5)*INDEX_Y(I,3,:) - 2._WP*INDEX(I,4)*INDEX_Y(I,2,:) ) &
                / ( INDEX(I,5) - 2._WP*INDEX(I,4) )
    END DO
    ! YMU, YLAMBDA, YMUZX
    WRITE(50) ( INDEX_Y(I,2,:), YLAM(I,:), INDEX_Y(I,1,:), I=1,N_CELLS )
  ELSE
    WRITE(50) ( INDEX_Y(I,1,:), INDEX_Y(I,1,:), INDEX_Y(I,1,:), I=1,N_CELLS )
  END IF
  CLOSE(50)


END SUBROUTINE WRITE_PARAMETERS
